/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*																		*/
/*		Ruputer۸ 											*/
/*		<<xmodem`>>     												*/
/*======================================================================*/

#include"lcdbios.h"
#include"wbios.h"
#include"rupsys.h"
#include"rsh.h"


#define	FAILED		-1
#define	SUCCEED		0

int init(int comkind, int baudrate)
{
	int err;
/*==================*/
/* ʐM߰ď	*/
/*==================*/
	err = bi_cominit(comkind, baudrate, 0, 10);

	if (err == FAILED) {
		return(ERR_COMINIT_FAILED);
	}
/*======================*/
/* ʐM߰ĵ		*/
/*======================*/

	err = bi_comopen();
	if (err == FAILED) {
		return(ERR_COMOPEN_FAILED);
	}

	return(SUCCEED);
}


void DownLoad(void)
{
	cls(4);
	gv_kput(10,10,"ð݂ɏ悹 ",0,0,0);
	gv_kput(10,22,"         ",0,0,0);

	while( !(bi_getbtn()&Bkey_SH) ){
		if (bi_scanbtn()&Bkey_D) return;
	}	/* Rs232cّ}҂ */
	cls(4);

	/* rs232c,19200bps */
	if (FAILED==init(2,4))
		return;

	gv_kput(10,10,"MJn ",0,0,0);
	gv_kput(10,22,"         ",0,0,0);

	dwlcall("\\hyperX.exf");
	bi_comclose();

}
void UpLoad(void)
{
	unsigned int dm,dt;

	cls(4);
	gv_kput(10,10,"ð݂ɏ悹 ",0,0,0);
	gv_kput(10,22,"         ",0,0,0);

	while( !(bi_getbtn()&Bkey_SH) ){
		if (bi_scanbtn()&Bkey_D) return;
	}	/* Rs232cّ}҂ */
	cls(4);

	dm = (unsigned)(1998-1980)*0x200U + (unsigned)8*0x20U + (unsigned)28U;
	dt = (unsigned)15*0x800U + (unsigned)19*0x20U + (unsigned)10U;

	/* rs232c,19200bps */
	if (FAILED==init(2,4))
		return;

	gv_kput(10,10,"MJn ",0,0,0);
	gv_kput(10,22,"         ",0,0,0);


	uplcall("\\upload.txt",256,dm,dt,0);
	bi_comclose();
}

