/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*                                                                      */
/*@\T		:	LCD-BIOSʃCN[ht@C					*/
/*																		*/
/*======================================================================*/


/*===============================================================
=		mojisize֐C^tF[X\̒`					=
===============================================================*/

struct moji {
	int		w ;								/* 					*/
	int		h ;								/* 					*/
	long	add ;							/* jAAhX			*/
} ;

/*===============================================================
=		֐vg^Cv錾									=
===============================================================*/

int			screen( int) ;
int			getscreen( void) ;
int			cls( int) ;
int			lcdon( int) ;
int			getlcdon( void) ;
int			mpread( char *, char *) ;
struct moji *mojisize( int) ;
int			getbufsize( int, int, int, int) ;
int			reverse( int, int, int, int) ;
int			revstop( int) ;
int			revstart( int) ;
int			revend( int) ;
int			revdraw( void) ;
int			blink( int, int, int, int, int) ;
int			blstop( int) ;
int			blstart( int) ;
int			blend( int) ;
int			lcdfreeze( int) ;
int			lcdvol( int) ;
int			getlcdvol( void) ;

int			gv_place( int, int) ;
int			gv_kput( int, int, char *, int, int, int) ;
int			gv_sput( int, int, int, int) ;
int			gv_aput( int, int, int, int, unsigned long, int) ;
int			gv_mmap( int, int, char *, int) ;
int			gv_line( int, int, int, int, int, unsigned char) ;
int			gv_square( int, int, int, int, int, unsigned long) ;
int			gv_circle( int, int, int, int, int, int, int, unsigned long, unsigned char *) ;
int			gv_pset( int, int, int) ;
int			gv_point( int, int) ;
int			gv_get( int, int, int, int, char *) ;
int			gv_put( int, int, char *, int) ;
int			gv_scroll( int) ;
int			gv_reverse( int, int, int, int) ;
int			gv_clear( int, int, int, int) ;

int			lc_kput( int, int, char *, int, int, int) ;
int			lc_sput( int, int, int, int) ;
int			lc_aput( int, int, int, int, unsigned long, int) ;
int			lc_mmap( int, int, char *, int) ;
int			lc_line( int, int, int, int, int, unsigned char) ;
int			lc_square( int, int, int, int, int, unsigned long) ;
int			lc_circle( int, int, int, int, int, int, int, unsigned long, unsigned char *) ;
int			lc_pset( int, int, int) ;
int			lc_point( int, int) ;
int			lc_get( int, int, int, int, char *) ;
int			lc_put( int, int, char *, int) ;
int			lc_reverse( int, int, int, int) ;
int			lc_clear( int, int,int, int) ;


/*===============================================================
=		֐vg^Cv錾	\̃C^[tF[X			=
===============================================================*/
typedef	struct {
	int x;
	int y;
} POINT;							/* W̒` */
typedef	struct {
	int x1;
	int y1;
	int x2;
	int y2;
} RECT;								/* ̈̒`iFx1 < x2,y1 < y2) */

int pv_place(POINT *);				/* GVRAM̕\Jnʒu */

typedef	struct {
	POINT pos;						/* ʒu */
	char *str;						/*  */
	int font;						/*  */
	int gap;						/*  */
	int lop;						/* _Z */
} KANJI_PUT;						/* ̕`̒` */
int pv_kput(KANJI_PUT *);			/* GVRAMɕiANK,S-JIS)̕` */
int pc_kput(KANJI_PUT *);			/* LCVRAMɕiANK,S-JIS)̕` */

typedef struct {
	POINT pos;						/* ʒu */
	unsigned short code;			/*  */
	int lop;						/* _Z */
} SIICODE_PUT;						/* SIIR[h̕`̒` */
int pv_sput(SIICODE_PUT *);			/* GVRAMSIIR[h̕` */
int pc_sput(SIICODE_PUT *);			/* LCVRAMSIIR[h̕` */

typedef struct {
	POINT pos;						/* ʒu */
	int width;						/*  */
	int hight;						/*  */
	unsigned long addr;				/* tHgf[^ AhX */
	int lop;						/* _Z */
} FONT_PUT;							/* tHgf[^̕`̒` */
int pv_aput(FONT_PUT *);			/* GVRAMɃtHgf[^̕` */
int pc_aput(FONT_PUT *);			/* LCVRAMɃtHgf[^̕` */

typedef struct {
	POINT pos;						/* ʒu */
	char *name;						/* t@C */
	int lop;						/* _Z */
} MMAP_PUT;							/* tbVMMPt@C̕`̒` */
int pv_mmap(MMAP_PUT *);			/* GVRAMɃtbVMMPt@C̕` */
int pc_mmap(MMAP_PUT *);			/* LCVRAMɃtbVMMPt@C̕` */

typedef struct {
	POINT st;						/* n_ */
	POINT ed;						/* I_ */
	int lop;						/* _Z */
	unsigned char txt;				/* CX^C */
} LINE_DRAW;						/* ̕`̒` */
int pv_line(LINE_DRAW *);			/* GVRAMɐ̕` */
int pc_line(LINE_DRAW *);			/* LCVRAMɐ̕` */

typedef struct {
	RECT rect;						/* Ώۗ̈ */
	int lop;						/* _Z */
	unsigned long txt;				/* CX^CA^Cp^[ */
} SQUARE_DRAW;
int pv_square(SQUARE_DRAW *squ);	/* GVRAMɗ̈g̕`^̕` */
int pc_square(SQUARE_DRAW *squ);	/* LCVRAMɗ̈g̕`^̕` */

typedef	struct {
	int xr;
	int yr;
} RADS;							/* a̒` */

typedef	struct {
	int d1;
	int d2;
} DEGR;							/* Jnpx̒` */

typedef struct {
	POINT pos;						/* ʒu */
	RADS rad;						/* a */
	DEGR deg;						/* Jnpx */
	int lop;						/* _Z */
	unsigned long txt;				/* CX^CA^Cp^[ */
	unsigned char *buf;				/* hԂp[N */
} CIRCLE_DRAW;
int pv_circle(CIRCLE_DRAW *cir);	/* GVRAMɑȉ~̈g̕`^̕` */
int pc_circle(CIRCLE_DRAW *cir);	/* LCVRAMɑȉ~̈g̕`^̕` */

typedef struct {
	POINT pos;						/* ʒu */
	int lop;						/* _Z */
} POINT_DRAW;						/* _̕`̒` */
int pv_pset(POINT_DRAW *);			/* GVRAMɓ_̕` */
int pc_pset(POINT_DRAW *);			/* LCVRAMɓ_̕` */

int pv_point(POINT *);				/* GVRAM̐F()擾 */
int pc_point(POINT *);				/* LCVRAM̐F()擾 */

typedef struct {
	RECT rect;						/* ̈ */
	char *buf;						/* AhX */
} GVRAM_GET;						/* GVRAM̓ǂݎ̒` */
int pv_get(GVRAM_GET *);			/* GVRAM̓ǂݎ */
int pc_get(GVRAM_GET *);			/* LCVRAM̓ǂݎ */

typedef struct {
	POINT pos;						/* ʒu */
	char *buf;						/* AhX */
	int lop;						/* _Z */
} GVRAM_PUT;						/* GVRAM֏o` */
int pv_put(GVRAM_PUT *);			/* GVRAM֏o */
int pc_put(GVRAM_PUT *);			/* LCVRAM֏o */

int pv_reverse(RECT *);				/* GVRAM̗̈𔽓] */
int pc_reverse(RECT *);				/* LCVRAM̗̈𔽓] */

int pv_clear(RECT *);				/* GVRAM̗̈NA */
int pc_clear(RECT *);				/* LCVRAM̗̈NA */

int pgetbufsize(RECT *);			/* LCDOtBbNp^[oCg擾 */

int preverse(RECT *);				/* LCD̔]̈w肷 */

typedef struct {
	RECT rect;						/* _ł̈ */
	int color;						/* _ŕ@̎w */
} BLINK_DRAW;						/* _ŗ̈̒` */
int pblink(BLINK_DRAW *);			/* _ŗ̈w肷 */
