/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*																		*/
/*		AD2COM2 dr												*/
/*		RS232C        												*/
/*======================================================================*/

#include<stdio.h>	/* CWײ sprintf */
#include<string.h>	/* CWײ strcpy */

#include"wbios.h"
#include"psdos.h"
#include"lcdbios.h"
#include"rupsys.h"	/* Ruputerͯ Bkey_**  */


/* MAIN.C Ŏg֐̃vg^Cv錾 */
void PwreadProc(void);			/* {̂main()̉ɂ܂ */
void ComProc(int);				/* {̂main()̉ɂ܂ */
void MessSend(char*,int);		/* {̂main()̉ɂ܂ */

int main(void)
{
    screen(1);

	cls(4);
	gv_kput(10,10,"ð݂ɏ悹 ",0,0,0);
	gv_kput(10,22,"         ",0,0,0);

	while( !(bi_getbtn()&Bkey_SH) ){}	/* Rs232cّ}҂ */
	cls(4);

	/* ʐM &  */
	ComProc(4);	/* ްڰ 4: 19.2kbps ̈ɂύX\ */
	lcdon(1);

    while( !(bi_getbtn()&Bkey_D) ){}	/* ƭŏI */

	gv_place(0,0);
	cls(4);
    gv_kput(0,2,"̌",0,0,0);
    gv_kput(30,40,"łH",0,0,0);
    cls(4);
}

void ComProc(int Bps)
{
	/* Bps:ްڰĂ̂ݐݒ\ */
	const int Dev=2;	/* Rs232c */
	const int Pulse=0;	/* ԊOٽARs232cł͓ɈӖȂ */
	const int Tout=10;	/* ѱĎ */

	/* ʐM */
	if( bi_cominit(Dev,Bps,Pulse,Tout) ){
		gv_kput(10,10,"ʐMNG ",0,0,0);	/* rs232cؒfĂ */
	}
	else if( bi_comclr() ){
		gv_kput(10,10,"ޯ̧NG",0,0,0);
	}
	else if( bi_comopen() ){
		gv_kput(10,10,"ڑ NG      ",0,0,0);
	}
	else{
		/* ʐM ڑ OK */
		gv_kput(10,10,"ڑ OK      ",0,0,0);

		/* M */
		PwreadProc(); /* ƭŖ߂܂ */

		/* ʐM ؒf */
		if( bi_comclose() ){
			gv_kput(10,10,"ؒf NG        ",0,0,0);
		}
		if( bi_cominit(0,0,0,0) ){
			gv_kput(10,10,"ʐMI NG    ",0,0,0);
		}
		else{
			gv_kput(10,10,"ʐMI       ",0,0,0);
		}
	}
}

void PwreadProc(void)
{
	int Key=0;
	char buff[32];
	int	volt;

    while( !(Key&Bkey_D) ){
	    Key=bi_getbtn();

		if( Key&Bkey_up ){
			lcdon(1);				/* LCDײON */
			MessSend("LCD ON\n\r",8);
		}
		if( Key&Bkey_dw ){
			lcdon(0);				/* LCDײOFF */
			MessSend("LCDOFF\n\r",8);
		}
		if( Key&Bkey_lf ){
			volt = bi_powerread();	/* dǍ */

			if( (unsigned int)volt<=255 ){
				sprintf(buff,"P0=%03d\n\r",(unsigned int)volt);	/* ϊ */
			}else{
				strcpy(buff,"VOLERR\n\r");
			}
			MessSend(buff,8);

			if( getlcdon() ){
				/* LCDʂɕ\ */
				buff[6]='\0';
				gv_kput(10,25,buff,2,0,0);
			}
		}
		if( Key&Bkey_rg ){
			volt = bi_powerread2();	/* d2Ǎ */

			if( (unsigned int)volt<=255 ){
				sprintf(buff,"P2=%03d\n\r",(unsigned int)volt);	/* ϊ */
			}else{
				strcpy(buff,"VOLERR\n\r");
			}
			MessSend(buff,8);

			if( getlcdon() ){
				/* LCDʂɕ\ */
				buff[6]='\0';
				gv_kput(10,37,buff,2,0,0);
			}
		}
		bi_clrbtn();
    }
}

void MessSend(char *write,int len)
{
	/* Ƃ肠AƂ len޲ Ԃ܂B */
	int  ret,num;

	if( ret=bi_complwrite(write,len,&num) ){
		if( ret==-2 ){
			gv_kput(10,10,"dG[",0,0,0);
		}
		else{
			gv_kput(10,10,"MG[",0,0,0);
		}
	}
}
