/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*																		*/
/*		Ruputer۸ 											*/
/*		<<RuputerAPI>>     												*/
/*======================================================================*/

#include "psdos.h"
#include "lcdbios.h"
#include "wbios.h"
#include "rupsys.h"
#include "font.h"
#include "softkey.h"

/* ݏdefine	*/
#define Key_file		0x0001		/*	swA(K0)荞	*/
#define Key_enter		0x0008		/*	swB(K3)荞	*/
#define Key_el			0x0004		/*	swC(K2)荞	*/
#define Key_menu		0x0002		/*	swD(K1)荞	*/
#define Key_left		0x0010		/*	swE(K4)荞	*/
#define Key_up			0x0020		/*	swF(K5)荞	*/
#define Key_right		0x0040		/*	swG(K6)荞	*/
#define Key_down		0x0080		/*	swH(K7)荞	*/

int com_getArg(void);
int com_Keyin(void);
int com_softkey(void);
int com_dispMess(void);
int com_dispMessBar(void);
int com_dispYN(void);
int com_dispYNLarge(void);
int com_dispCancelYN(void);
int com_dispWaiting(void);
int com_dispVOLerr(void);
int com_dispMEMORYerr(void);
int com_dispTitle(void);
int com_dispTitleMore(void);
int com_sendTime(void);
int com_recvTime(void);
int com_sendFile(void);
int com_recvFile(void);
int com_TIMERStart(void);
int com_dispTime(void);
int com_dos_freespace(void);
int com_dos_freesect(void);
int com_CheckVol(void);	

static const RECT CLRLCD={0,0,101,63};
static MENU menuLIST[]={
	{ com_getArg,		"getArg@@@@@@",0,0},
	{ com_Keyin,		"Keyin   @@@@@",0,0},
	{ com_softkey,		"softkey @@@@@",0,0},
	{ com_dispMess,		"dispMess    @@@",0,0},
	{ com_dispMessBar,	"dispMessBar    @ ",0,0},
	{ com_dispYN,		"dispYN         @ ",0,0},
	{ com_dispYNLarge,	"dispYNLarge    @ ",0,0},
	{ com_dispCancelYN,	"dispCancelYN   @ ",0,0},
	{ com_dispWaiting,	"dispWaiting    @ ",0,0},
	{ com_dispVOLerr,	"dispVOLerr     @ ",0,0},
	{ com_dispMEMORYerr,"dispMEMORYerr  @ ",0,0},
	{ com_dispTitle,	"dispTitle      @ ",0,0},
	{ com_dispTitleMore,"dispTitleMore  @ ",0,0},
	{ adjTime,			"adjTime        @ ",0,0},
	{ com_sendTime,		"sendTime       @ ",0,0},
	{ com_recvTime,		"recvTime       @ ",0,0},
	{ com_sendFile,		"sendFile       @ ",0,0},
	{ com_recvFile,		"recvFile       @ ",0,0},
	{ com_TIMERStart,	"TIMERStart,Stop@ ",0,0},
	{ com_dispTime,		"dispTime          ",0,0},
	{ com_dos_freespace,"dos_freespace  @ ",0,0},
	{ com_dos_freesect,	"dos_freesect   @ ",0,0},
	{ com_CheckVol,		"CheckVol       @ ",0,0},
};

/*-----------------------------------------------------------*/
/*	 getArgFNt@C̎擾  							 */
/*-----------------------------------------------------------*/
int com_getArg(void)
{
	KANJI_PUT Fname = {{0,0},0,0,0,0};

	Fname.str = getArg();
	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	pv_kput((KANJI_PUT *)&Fname);	/* Ņٖ̕\ */
	while(1){
		Keyin(0,-1);
		return 0;
	}
}
/*-----------------------------------------------------------*/
/*	 KeyinF{^Ԃ̎擾	  							 */
/*-----------------------------------------------------------*/
int com_Keyin(void)
{
	KANJI_PUT Mess[] = {
		{{0,0},"҂Ԃł",0,0,0},
		{{0,13},"AnyŔ܂",0,0,0}
	};
	int bt;
	int ret;

	while(1){
		/* EventExec甲Ƃɉʍĕ`悵܂ */
		pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
		pv_kput((KANJI_PUT *)&Mess[0]);
		pv_kput((KANJI_PUT *)&Mess[1]);
		bt = Keyin(0,-1);
		ret = EventCall(bt);
		if( ret == -1 ){
			/* عݏIv */
			dos_exit(0);
		}
		else if( ret == 1 ){
			ret = EventExec();
			if (ret == -1){
				/* عݏIv */
				dos_exit(0);
			}
		}
		else return 0;/* L[͂Ɣ܂B*/
	}
}
/*-----------------------------------------------------------*/
/*	 softkeyF\tgL[		  							 */
/*-----------------------------------------------------------*/
int com_softkey(void)
{
	KANJI_PUT Mess = {{0,0},"EnterſķN",0,0,0};
	KANJI_PUT Inputstr = {{0,26},"",0,0,0};
	STRSTS ctrl = { picNAME	,HIRAGANA_TYPE,	ZEN_SZ,0,0,0,16};
	int bt;

	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	pv_kput((KANJI_PUT *)&Mess);
	while(1){
		bt = bi_getbtn();
		if( bt==Key_menu ){
			return 0;
		}
		else if( bt==Key_enter ){
			if( softkey( &ctrl,Inputstr.str,0,0 )==-1 )
				/* ԋpl-1ȂعݏI */
				dos_exit(0);
			pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
			pv_kput((KANJI_PUT *)&Inputstr);
		}
	}
}
/*-----------------------------------------------------------*/
/*	 dispMessFbZ[W\	  							 */
/*-----------------------------------------------------------*/
int com_dispMess(void)
{
	char *Mess[] = {
		" bZ[W",
		"Sp7~3s܂",
		/* ׂ߲̕s0x5C2byteނ܂Ȃ߂
			Ή\} */
		" \\ł܂"
	};
	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	dispMess( (char **)Mess, 3 );
	return 0;
}
/*-----------------------------------------------------------*/
/*	 dispMessBarFSpR{o[\						 */
/*-----------------------------------------------------------*/
int com_dispMessBar(void)
{
	KANJI_PUT Mess = {{0,0},"AnyŏI",0,0,0};

	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	pv_kput((KANJI_PUT *)&Mess);
	dispMessBar("쒆");
	Keyin(0,-1);
	/* dispMessBar֐Ă񂾌́AKendMessBarŏI悤ɂB*/
	endMessBar();
	return 0;
}

/*-----------------------------------------------------------*/
/*	 dispYNFx/mmF\iWj					 */
/*-----------------------------------------------------------*/
int com_dispYN(void)
{
	int ret;

	while(1){
		pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
		if( (ret=dispYN("̂܂܏I","܂H",0))==-1 )
			/* ԋpl-1ȂعݏI */
			dos_exit(0);
		else if( !ret ) return 0;/* ԋpl0ȂYes */
	}
}
/*-----------------------------------------------------------*/
/*	 dispYNLargeFx/mmF\igj				 */
/*-----------------------------------------------------------*/
int com_dispYNLarge(void)
{
	int ret;

	while(1){
		pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
		if( (ret=dispYNLarge("̂܂܏I","H",0))==-1 )
			/* ԋpl-1ȂعݏI */
			dos_exit(0);
		else if( !ret ) return 0;/* ԋpl0ȂYes */
	}
}
/*-----------------------------------------------------------*/
/*	 dispCancelYNFݒ̷ݾ Yes/No\					 */
/*-----------------------------------------------------------*/
int com_dispCancelYN(void)
{
	int ret;

	while(1){
		pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
		if( (ret=dispCancelYN())==-1 )
			/* ԋpl-1ȂعݏI */
			dos_exit(0);
		else if( !ret ) return 0;/* ԋpl0ȂYes */
	}
}
/*-----------------------------------------------------------*/
/*	 dispWaitingF҂ WaitAnimation\					 */
/*-----------------------------------------------------------*/
int com_dispWaiting(void)
{
	KANJI_PUT Mess = {{0,0},"AnyŏI",0,0,0};

	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	pv_kput((KANJI_PUT *)&Mess);
	dispWaiting();
	/* L[̗オƗłQ񊄂荞݂邽
		 bi_getbtn͂Q*/
	bi_getbtn();
	bi_getbtn();
	/* dispWaiting֐Ă񂾌́AKendWaitingŏI悤ɂB*/
	/* Keyin֐̐擪ł~܂ */
	endWaiting();
	return 0;
}
/*-----------------------------------------------------------*/
/*	 dispVOLerrFdُx\							 */
/*-----------------------------------------------------------*/
int com_dispVOLerr(void)
{
	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	dispVOLerr();
	/* ʏ͂̌dos_exit(0);悤ɂ */
	bi_getbtn();
	return 0;
}
/*-----------------------------------------------------------*/
/*	 dispMEMORYerrFُُx\					 */
/*-----------------------------------------------------------*/
int com_dispMEMORYerr(void)
{
	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	dispMEMORYerr();
	/* ʏ͂̌dos_exit(0);悤ɂ */
	bi_getbtn();
	return 0;
}
/*-----------------------------------------------------------*/
/*	 dispTitleFݒʃ^Cg\						 */
/*-----------------------------------------------------------*/
int com_dispTitle(void)
{
	KANJI_PUT Mess = {{0,26},"ق\\܂",0,0,0};
	/* ׂ߲̕s0x5C2byteނ܂Ȃ߂
		Ή\} */

	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	dispTitle("Ruputerݒ");
	pv_kput((KANJI_PUT *)&Mess);
	Keyin(0,-1);
	return 0;
}
/*-----------------------------------------------------------*/
/*	 dispTitleMoreFݒʃ^Cg\i㉺ꍇj */
/*-----------------------------------------------------------*/
int com_dispTitleMore(void)
{
	int csr,listno;
	int bt;
	int listmax;
	int i,j;
	int ret;
	char buf[1024];
	GVRAM_GET SCROLLget[]={
		{{0,13,101,50},0},
		{{0,26,101,63},0}
	};
	GVRAM_PUT SCROLLput[]={
		{{0,26},0,0},
		{{0,13},0,0}
	};
	KANJI_PUT Listkput = {{1,0},0,0,0,0};
	const GVRAM_PUT UEYAput={{83,3},(char *)mmpUEYA,0};
	const GVRAM_PUT SITAYAput={{92,3},(char *)mmpSITAYA,0};
	const SQUARE_DRAW UEYAsqu={{83,3,91,8},0x0004,0x55aa55aa};
	const SQUARE_DRAW SITAYAsqu={{92,3,100,8},0x0004,0xaa55aa55};
	const RECT REV4[]={
			{0,12,101,25},
			{0,25,101,38},
			{0,38,101,51},
			{0,51,101,63}
	};
	char *List[] = {
		"i",
		"i",
		"Oi",
		"li",
		"ܒi",
		"Zi"
	};

	csr = 0;
	listno = 0;
	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	listmax = sizeof(List)/sizeof(char *);
	while(1){
		lcdfreeze(1);
		dispTitle("List\\");		/* ٕ\			*/
		if(listmax-csr>4)
					pv_put((GVRAM_PUT *)&SITAYAput);/*	\	*/
		if(csr)		pv_put((GVRAM_PUT *)&UEYAput);	/*	\	*/
		for( i=0,j=listno;i<4;i++,j++ ){	/*	ƭڕ\	*/
			Listkput.pos.y = 13+i*13;
			Listkput.str = List[j];
			pv_kput((KANJI_PUT *)&Listkput);
		}
		pv_reverse((RECT *)&REV4[csr]);	/*	reverse		*/
		lcdfreeze(0);
		while(1){
			bt = Keyin((Key_up|Key_down),-1);
			ret = EventCall(bt);
			if( ret == -1 ){
				/* عݏIv */
				dos_exit(0);
			}
			else if( ret == 1 ){
				ret = EventExec();
				if (ret == -1){
					/* عݏIv */
					dos_exit(0);
				}
			}
			if( bt==Key_menu ){
				return 0;
			}
			else if( bt==Key_up && listno ){
				pv_reverse((RECT *)&REV4[csr]);		/*	reverse	*/
				listno --;
				if(csr!=0)	csr--;
				else{/*	ʽ۰	*/
					if(!listno)	pv_square((SQUARE_DRAW *)&UEYAsqu);	/**/
					if(listno+3<listmax-1)	
								pv_put((GVRAM_PUT *)&SITAYAput);	/*\*/
					SCROLLget[0].buf=buf;
					pv_get((GVRAM_GET *)&SCROLLget[0]);
					Listkput.pos.y = 13;
					Listkput.str = List[listno];
					pv_kput((KANJI_PUT *)&Listkput);
					SCROLLput[0].buf=buf;
					pv_put((GVRAM_PUT *)&SCROLLput[0]);
				}
				pv_reverse((RECT *)&REV4[csr]);		/*	reverse	*/
			}
			else if( bt==Key_down && listno!=listmax-1 ){
				pv_reverse((RECT *)&REV4[csr]);		/*	reverse	*/
				listno ++;
				if(csr<3)	csr++;
				else{/*	ʽ۰	*/
					if(listno==listmax-1)	pv_square((SQUARE_DRAW *)&SITAYAsqu);	/**/
					if(listno==4)			pv_put((GVRAM_PUT *)&UEYAput);			/*\*/
					SCROLLget[1].buf=buf;
					pv_get((GVRAM_GET *)&SCROLLget[1]);
					Listkput.pos.y = 52;
					Listkput.str = List[listno];
					pv_kput((KANJI_PUT *)&Listkput);
					SCROLLput[1].buf=buf;
					pv_put((GVRAM_PUT *)&SCROLLput[1]);
				}
				pv_reverse((RECT *)&REV4[csr]);		/*	reverse	*/
			}
		}
	}
}
/*-----------------------------------------------------------*/
/*	 adjTimeFԏC										 */
/*-----------------------------------------------------------*/
/* j[͂̂܂܌ĂԂƂł܂ */

/*-----------------------------------------------------------*/
/*	 ԃf[^ʐM											 */
/*-----------------------------------------------------------*/
/* 
	errcodeԋpl
	-1	 ʐM߰ĂgpłȂ
	-2	 ʐM̴װ
	-3	 ݑŷݾ
	-4	 drW݂o
	-5	 ѱ
	-6	 肩緬ݾقꂽ
*/
#define	BLDSTOP			-4	/* drW݂o			*/
#define	TIMEOUTerr		-5	/* ѱ						*/
static char *eMess0[] = {"@","@܂"};
static char *eMess1[] = {"@Mf","@܂"};
static char *eMess2[] = {"@Mf","@܂"};
/*-----------------------------------------------------------*/
/*	 sendTimeFԃf[^M								 */
/*-----------------------------------------------------------*/
int com_sendTime(void)
{
	int ret;
	int rst;
	KANJI_PUT Mess[] = {
		{{ 21, 15},"M",0,0,0},
		{{ 21,  0},"ް",0,0,0}
	};

	rst = dispYN("ް","M܂?",0);
	if( rst == -1 )	dos_exit(0);
	if( !rst ){
		pv_clear((RECT *)&CLRLCD);
		pv_kput((KANJI_PUT *)&Mess[0]);
		pv_kput((KANJI_PUT *)&Mess[1]);
		ret = sendTime();
		if( !ret ){
			dispMessBar("M");
			endMessBar();
			return 0;
		}
		else if(ret==BLDSTOP)	dos_exit(0);
		else if(ret==TIMEOUTerr){
			/* Mѱ */
			if ((dispMess(eMess0,2)) == -1) dos_exit(0);
			return 0;
		}
		else{/* Mf */
			if ((dispMess(eMess1,2)) == -1) dos_exit(0);
			return 0;
		}
	}
	return 0;
}
/*-----------------------------------------------------------*/
/*	 recvTimeFԃf[^M								 */
/*-----------------------------------------------------------*/
int com_recvTime(void)
{
	int ret;
	int rst;
	WatchDT getRTCTime;
	KANJI_PUT Mess[] = {
		{{ 21, 15},"M",0,0,0},
		{{ 21,  0},"ް",0,0,0}
	};

	rst = dispYN("ް","M܂?",0);
	if( rst == -1 )	dos_exit(0);
	if( !rst ){
		pv_clear((RECT *)&CLRLCD);
		pv_kput((KANJI_PUT *)&Mess[0]);
		pv_kput((KANJI_PUT *)&Mess[1]);
		ret=recvTime(&getRTCTime);
		if( !ret ){
			*pSystemCtl->CPUram=getRTCTime;
			/* Mf[^q`lɏ */
			dispMessBar("M");
			/* ύX̕Kvȏ */
			setRTC();				/* RTCZbg 		*/
			setRTCquit();
			setPowerStandby();
			CheckExecute();			/* CHECK.EXFN	*/
			/* ܂ŕKv */
			return 0;
		}
		else if(ret==BLDSTOP)	dos_exit(0);
		else if(ret==TIMEOUTerr){
			/* Mѱ */
			if ((dispMess(eMess0,2)) == -1) dos_exit(0);
			return 0;
		}
		else{/* Mf@*/
			if ((dispMess(eMess2,2)) == -1) dos_exit(0);
			return 0;
		}
	}
	return 0;
}
/*-----------------------------------------------------------*/
/*	 t@CʐM											 */
/*-----------------------------------------------------------*/
/*
	errcodeԋpl
		 0	I
		-1	肩緬ݾقꂽ
		-2	ʐMѱ(M)
		-3	sȺ
		-4	ڰ(݂ɂ钆f)
		-5	肩牞
		-6	̧٥ײĴװ
		-7	ʐM߰ĂgpłȂ
		-8	drW݂o
		-9	do
		-11	ʐMѱ(M)
*/
static const char *eMess00[] =	{"@","@܂"};
static const char *eMess01[] =	{"@Mf","@܂"};
static const char *eMess02[] =	{"@Mf","@܂"};
static const char *eMess03[] =	{"@MI","@܂"};
static const char *eMess04[] =	{"@MI","@܂"};
static char *comtest = "test";
/*-----------------------------------------------------------*/
/*	 sendFileFt@CM									 */
/*-----------------------------------------------------------*/
int com_sendFile(void)
{
	int fp,ret,err;

	ret = dispYN( "testf[^","M܂?",0 );
	if( ret == -1 )	dos_exit(0);
	if( !ret ){
		if( dos_freespace(sizeof(comtest)) ){
			dispMEMORYerr();
			dos_exit(0);
		}
		dispMessBar("");
		if( (fp=dos_fcreate("B:\\SYSTEM\\SEND.TMP") )==-1 ){
			/* err */
			endMessBar();
			return 0;
		}
		else if( fp==-2 ){
			/* dُ */
			endMessBar();
			dispVOLerr();
			dos_exit(0);
		}
		dos_fwrite( fp,comtest,sizeof(comtest) );
		dos_fclose( fp );
		bi_vwrflush();
		fp = dos_fopen( "B:\\SYSTEM\\SEND.TMP",0 );
		endMessBar();
		err = sendFile( "testް",fp,sizeof(comtest) );
		dos_fclose( fp );
		dos_fdelete( "B:\\SYSTEM\\SEND.TMP" );
		if( err ){
			switch( err ){
				case	-5:
						if( dispMess( (char **)eMess00, 2 )==-1 )	dos_exit(0);
						break;
				case	-8:
				case	-9:
						dispVOLerr();
						dos_exit(0);
				default:/* Mf */
						if( dispMess( (char **)eMess01, 2 )==-1 ) dos_exit(0);
			}
			return 0;
		}
		/* M */
		if( dispMess( (char **)eMess03, 2 )==-1 )	dos_exit(0);
		return 0;
	}
	return 0;
}
/*-----------------------------------------------------------*/
/*	 recvFileFt@CM									 */
/*-----------------------------------------------------------*/
int com_recvFile(void)
{
	int fp,ret,err;
	char mess[5];

	ret = dispYN( "testf[^","M܂?",0 );
	if( ret == -1 )	dos_exit(0);
	if( !ret ){
		/* 󂫗e */
		if( dos_freespace(sizeof(comtest)) ){
			dispMEMORYerr();
			dos_exit(0);
		}
		if( (fp=dos_fcreate("B:\\SYSTEM\\SEND.TMP") )==-1 ){
			/* err */
			return 0;
		}
		else if( fp==-2 ){
			/* dُ */
			dispVOLerr();
			dos_exit(0);
		}
		pv_clear((RECT *)&CLRLCD);
		err = recvFile( "testް",fp );
		dos_fclose( fp );
		bi_vwrflush();
		if( err ){
			dos_fdelete( "B:\\SYSTEM\\SEND.TMP" );
			switch( err ){
				case	-2:
						if( dispMess( (char **)eMess00, 2 )==-1 )	dos_exit(0);
						break;
				case	-9:
						dispVOLerr();
				case	-8:
						dos_exit(0);
				case	-10:
						dispMEMORYerr();
						dos_exit(0);
				default:/* Mf */
						if( dispMess( (char **)eMess02, 2 )==-1 ) dos_exit(0);
			}
			return 0;
		}
		dispMessBar("ۑ");
		fp = dos_fopen( "B:\\SYSTEM\\SEND.TMP",0 );
		dos_fread( fp,mess,sizeof(comtest) );
		dos_fclose( fp );
		dos_fdelete( "B:\\SYSTEM\\SEND.TMP" );
		endMessBar();
		if( dispMess( (char **)eMess04, 2 )==-1 )	dos_exit(0);
		return 0;
	}
	return 0;
}
/*-----------------------------------------------------------*/
/*	 TIMERStart,TIMERStopF^C}[						 */
/*-----------------------------------------------------------*/
#define RESET			0		/*	RESET		*/
#define STOP			1		/*	STOP		*/
#define RUN				2		/*	RUN			*/
static Tdata TMRdt;
/*	 l𱽷ނɕϊ(scosiiގgp)	 */
static void INTtoASC(char *p,int val,int keta,int sup)
{
	int i;

	for(p[keta]='\0',i=keta-1;0<=i;i--){
		p[i]=val%10+0x30;
		if(i!=keta-1 && sup==1 && p[i]=='0')	p[i]='?';
		val /= 10;
	}
	return;
}
/*	 ^C}[\	 */
static void dispTimer(void)
{
	char buf[3];
	KANJI_PUT TMRkput[]={
		{{20,19},0,0,0,0},		/*		*/
		{{26,19},":",0,0,0},	/*	F	*/
		{{32,19},0,0,0,0},		/*		*/
		{{46,19},0,0,0,0}		/*	b	*/
	};
	/* RAM̶̒lǂݍ */
	TMRdt = *pSystemCtl->TIMERdata;
	/* ϰ\ */
	INTtoASC(buf,TMRdt.hour,1,0);
	TMRkput[0].str=buf;
	pv_kput((KANJI_PUT *)&TMRkput[0]);	/*  */
	pv_kput((KANJI_PUT *)&TMRkput[1]);	/* F */
	INTtoASC(buf,TMRdt.min,2,0);
	TMRkput[2].str=buf;
	pv_kput((KANJI_PUT *)&TMRkput[2]);	/*  */
	INTtoASC(buf,TMRdt.sec,2,0);
	TMRkput[3].str=buf;
	pv_kput((KANJI_PUT *)&TMRkput[3]);	/*  */
}
int com_TIMERStart(void)
{
	int bt,ret;
	KANJI_PUT TimeupMess = {{0,0},"TimeUp",0,0,0};
	int Timeup = 0;

	/* ϰ10bɃZbg */
	TMRdt.hour=0;
	TMRdt.min=0;
	TMRdt.sec=10;
	TMRdt.co=0;
	*pSystemCtl->TimerStat=RESET;	/* ϰؾďԁ@	*/
	*pSystemCtl->TIMERdata=TMRdt;	/* RAMϰް	*/
	pv_clear((RECT *)&CLRLCD);
	lcdfreeze(1);
	dispTimer();
	lcdfreeze(0);
	while(1){
		bt = Keyin(0,-1);
		if(bt & EVENT_REQ){/* ѱߏ̎擾@*/
			if ((pSystemCtl->EventManager->eventReq & EVENT_TMDWN1) &&
			    (pSystemCtl->EventManager->event    & EVENT_TMDWN1)) {	/* ѱ	*/
				pv_kput((KANJI_PUT *)&TimeupMess);/*ѱүޕ\ */
				/* PbKeyin甲鏈	*/
				pSystemCtl->EventManager->eventReq &=~ EVENT_TMDWN2;
				dispTimer();
				Timeup = 1;
			}
		}
		ret = EventCall(bt);
		/*	ѱߏ𕜋A	*/
		if (ret == -1) {
			/* عݏIv */
			if(*pSystemCtl->TimerStat==RUN){
				/* PbKeyin甲鏈	*/
				pSystemCtl->EventManager->eventReq &=~ EVENT_TMDWN2;
			}
			dos_exit(0);
		}
		else if (ret == 1) {
			/* TimeŊ荞݋NȂȂ邽߈U~߂ */
			if(*pSystemCtl->TimerStat==RUN){
				/* PbKeyin甲鏈	*/
				pSystemCtl->EventManager->eventReq &=~ EVENT_TMDWN2;
			}
			ret = EventExec();
			if (ret == -1) {
				/* عݏIv */
				dos_exit(1);
			}
			pv_clear((RECT *)&CLRLCD);
			dispTimer();
			if( *pSystemCtl->TimerStat == RUN ){/* RUNȂ犄荞ݕA */
				/* PbKeyin甲鏈ݒ	*/
				pSystemCtl->EventManager->eventReq |= EVENT_TMDWN2;
			}
		}
		if(bt & EVENT_REQ){
			/* PbKeyin甲銄荞ݏ	*/
			if ((pSystemCtl->EventManager->eventReq & EVENT_TMDWN2) &&
			    (pSystemCtl->EventManager->event    & EVENT_TMDWN2)) {
			    pSystemCtl->EventManager->event &= ~EVENT_TMDWN2;
				dispTimer();
			}
		}
		if(bt==Key_enter){
			if( Timeup ) return 0;
			if(*pSystemCtl->TimerStat==STOP ||
				*pSystemCtl->TimerStat==RESET){
				TIMERStart();
				/* ϰRUN */
				*pSystemCtl->TimerStat=RUN;
				/* ϰ荞ݐݒ */
				pSystemCtl->EventManager->eventReq |= (EVENT_TMDWN0|EVENT_TMDWN1|EVENT_TMDWN2);
			}
			else if(*pSystemCtl->TimerStat==RUN){
				TIMERStop();
				/* ϰSTOP */
				*pSystemCtl->TimerStat=STOP;
				/* PbKeyin甲鏈	*/
				pSystemCtl->EventManager->eventReq &=~ EVENT_TMDWN2;
				dispTimer();
			}
		}
		else if(bt==Key_menu){
			if(*pSystemCtl->TimerStat==STOP){
				*pSystemCtl->TimerStat=RESET;
				TMRdt.hour=0;
				TMRdt.min=0;
				TMRdt.sec=10;
				TMRdt.co=0;
				*pSystemCtl->TIMERdata=TMRdt;	/* RAMϰް	*/
				dispTimer();
			}
			else{
				/* PbKeyin甲鏈	*/
				TIMERStop();
				pSystemCtl->EventManager->eventReq &=~ EVENT_TMDWN2;
				return 0;
			}
		}
	}
}
/*-----------------------------------------------------------*/
/*	 dispNowWeek,dispNowDate,dispNowAmPm					 */
/*	 dispNowTime,dispNowSecFԕ\						 */
/*-----------------------------------------------------------*/
int com_dispTime(void)
{
	WatchDT Time;
	int chgHour;
	KANJI_PUT Mess = {{25,51},"ݎł",0,0,0};

	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	pv_kput((KANJI_PUT *)&Mess);
	Time = *pSystemCtl->CPUram;/* RAM̎ްǂݍ */
	chgHour = dispNowTime(  4, 31, 42, 24, 60, 3, 1 );	/*  	*/
	dispNowSec( 74, 31, 48, 2, 1 );						/* b 		*/
	if( chgHour ){
		/* ȉωƂ̂ݕ\ */
		dispNowAmPm( 5, 53, 16, 1 );					/*AM/PM		*/
		dispNowDate( 0,  4, 32, 1, 0 );					/* N 	*/
		dispNowWeek(84,  6,  0, 0, 0 );					/* j 	*/
	}
	Keyin(0,-1);
	return 0;
}
/*-----------------------------------------------------------*/
/*	 dos_freespaceF󂫗eʃ`FbNioCgPʁj			 */
/*-----------------------------------------------------------*/
int com_dos_freespace(void)
{
	KANJI_PUT Mess[] = {
		{{1,0},"ceʂ",0,0,0},
		{{1,13},"10kbyteȏł",0,0,0},
		{{1,13},"10kbyteȉł",0,0,0},
	};

	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	pv_kput((KANJI_PUT *)&Mess[0]);
	if( !dos_freespace(10000) )
			pv_kput((KANJI_PUT *)&Mess[1]);
	else	pv_kput((KANJI_PUT *)&Mess[2]);
	Keyin(0,-1);
	return 0;
}
/*-----------------------------------------------------------*/
/*	 dos_freesectF󂫗eʃ`FbNiZN^Pʁj			 */
/*-----------------------------------------------------------*/
int com_dos_freesect(void)
{
	KANJI_PUT Mess[] = {
		{{1,0},"ceʂ",0,0,0},
		{{1,13},"100ȏł",0,0,0},
		{{1,13},"100ȉł",0,0,0},
	};

	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	pv_kput((KANJI_PUT *)&Mess[0]);
	if( !dos_freesect(100) )
			pv_kput((KANJI_PUT *)&Mess[1]);
	else	pv_kput((KANJI_PUT *)&Mess[2]);
	Keyin(0,-1);
	return 0;
}
/*-----------------------------------------------------------*/
/*	 CheckVolFdדd`FbN							 */
/*-----------------------------------------------------------*/
int com_CheckVol(void)
{
	KANJI_PUT Mess[] = {
		{{10,0},"d",0,0,0},
		{{10,0},"dُ",0,0,0},
	};

	pv_clear((RECT *)&CLRLCD);		/* ʃNA 		*/
	if( !CheckVol() )
			pv_kput((KANJI_PUT *)&Mess[0]);
	else	pv_kput((KANJI_PUT *)&Mess[1]);
	Keyin(0,-1);
	return 0;
}
/*-----------------------------------------------------------*/
/*	 C					      							 */
/*-----------------------------------------------------------*/
int main(void)
{
	screen(1);						/*	̨Ӱ				*/
	gv_place(0,0);					/*	XYW@X:0, Y:0		*/
	endWaiting();					/*	NҰ݂̒~	*/
	if( aprMenu("RuputerAPI",menuLIST,
				(int)sizeof(menuLIST)/sizeof(MENU)) == -2 )
		dos_exit(0);	/* ع݂̏I	*/
	return 0;
}
