/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*																		*/
/*		Ruputer۸ 											*/
/*		<<̫ĕ\>>     												*/
/*======================================================================*/

#include "string.h"
#include "psdos.h"
#include "lcdbios.h"
#include "wbios.h"
#include "rupsys.h"
#include "font.h"

/* ݏdefine	*/
#define Key_file		0x0001		/*	swA(K0)荞	*/
#define Key_enter		0x0008		/*	swB(K3)荞	*/
#define Key_el			0x0004		/*	swC(K2)荞	*/
#define Key_menu		0x0002		/*	swD(K1)荞	*/
#define Key_left		0x0010		/*	swE(K4)荞	*/
#define Key_up			0x0020		/*	swF(K5)荞	*/
#define Key_right		0x0040		/*	swG(K6)荞	*/
#define Key_down		0x0080		/*	swH(K7)荞	*/

/*	fontޕð	*/
const static int ScodeWide[]={	 12,12,12, 6, 5, 6, 6, 6, 3, 3,
								  3, 4, 5, 0, 0, 0, 5, 5, 0, 5,
								  6, 0, 0, 0, 6, 6, 6, 0, 0, 0,
								  0, 0, 7, 7, 0, 0, 0, 0, 0, 0,
								  9, 9, 0, 0, 0, 0, 0, 0,11,11,
								 11, 0, 0, 0, 0, 0,13,13,13,13,
								 13
};
const static int ScodeHight[]={	 12,10, 8,12, 7,12,10, 8, 5, 7,
								  9, 9, 7, 0, 0, 0, 9, 9, 0,10,
								 11, 0, 0, 0,13,13,13, 0, 0, 0,
								  0, 0,13,13, 0, 0, 0, 0, 0, 0,
								 16,16, 0, 0, 0, 0, 0, 0,17,17,
								 17, 0, 0, 0, 0, 0,19,19,19,19,
								 24
};
/*-----------------------------------------------------------*/
/*	 l𱽷ނɕϊ	      							 */
/*-----------------------------------------------------------*/
static void INTtoASC(char *p,int val,int keta,int sup)
{
	int i;

	for(i=keta-1;0<=i;i--){
		p[i]=val%10+0x30;
		if(i!=keta-1 && sup==1 && p[i]=='0')	p[i]=' ';
		val /= 10;
	}
	return;
}
/*-----------------------------------------------------------*/
/*	 tHg\			      							 */
/*-----------------------------------------------------------*/
static void dispFont( int no )
{
	int i;
	char buf[2] = " ";
	KANJI_PUT font = {{0,0},buf,no,1,0};
	const RECT CLR={0,13,114,63};
	int f = 0;
	int imem;
	
	pv_clear((RECT *)&CLR);
	/* tHg\̈NA */
	if( no >= 0 && no <= 2 ){/* S_JIS,ANK  */
		gv_kput(0,13,"OPQRSTUV",no,0,0);
		gv_kput(0,(ScodeHight[no]+1)+13,
			"WXF0123456789:",no,0,0);
		gv_kput(0,(ScodeHight[no]+1)*2+13,
			"͂߂܂Ėl",no,0,0);
		gv_kput(0,(ScodeHight[no]+1)*3+13,
			"Ђ͂r",no,0,0);
		/*
			gv_kputpv_kputł\\
			pv_kputgv_kputɔׂĈȂȂ邽
			팸Ɍʂ
		*/
	}
	else if( no == 3 ){/* SpނŔp\ */
		gv_kput(0,13,"OPQRSTUVWXF|",no,0,0);
		gv_kput(0,(ScodeHight[no]+1)+13,
			"yz{|}~@`abc",no,0,0);
		gv_kput(0,(ScodeHight[no]+1)*2+13,
			"AJT^in}@Ȃ͂܂",no,0,0);
		gv_kput(0,(ScodeHight[no]+1)*3+13,
			"@@ABCpqrs",no,0,0);
		/*
			gv_kputpv_kputł\\
			pv_kputgv_kputɔׂĈȂȂ邽
			팸Ɍʂ
		*/
	}
	else if( no == 4 ){/* SpނŔp\ */
		gv_kput(0,13,"OPQRSTUVWXF|",no,1,0);
		gv_kput(0,(ScodeHight[no]+1)+13,
			"{|~H",no,1,0);
		gv_kput(0,(ScodeHight[no]+1)*2+13,
			"`abc",no,1,0);
		gv_kput(0,(ScodeHight[no]+1)*3+13,
			"AJT^in}",no,1,0);
		gv_kput(0,(ScodeHight[no]+1)*4+13,
			"Ȃ͂܂",no,1,0);
		/*
			gv_kputpv_kputł\\
			pv_kputgv_kputɔׂĈȂȂ邽
			팸Ɍʂ
		*/
	}
	else if( no >= 5 && no <= 7 ){/* p̫߰ĕ\ */
		gv_kput(0,13,"0123456789:-",no,0,0);
		gv_kput(0,(ScodeHight[no]+1)+13,"ABCDEFGHIJKLMNOPQ",no,0,0);
		gv_kput(0,(ScodeHight[no]+1)*2+13,"RSTUVWXYZ abcdefg",no,0,0);
		gv_kput(0,(ScodeHight[no]+1)*3+13,"hijklmnopqrstuvwxyz",no,0,0);
		/*
			gv_kputpv_kputł\\
			pv_kputgv_kputɔׂĈȂȂ邽
			팸Ɍʂ
		*/
	}
	else{
		for( i = 0; i < 15 ; i ++ ){/* ̫ĕ\ */
			font.pos.x = (ScodeWide[no]+1)*i+1;
			font.pos.y = 13;
			if( (ScodeWide[no]+1)*(i+1)+1 > 101 ){
				if( !f ){
					f = 1;
					imem = i;
				}
				font.pos.x = (ScodeWide[no]+1)*(i-imem)+1;
				font.pos.y = 15 + ScodeHight[no];
			}
			if( i < 10 )	INTtoASC( buf,i,1,0 );
			else{
				switch( i ){
					case 10:buf[0] = ':';/* : */
							break;
					case 11:buf[0] = ';';/* - */
							break;
					case 12:buf[0] = '<';/* A */
							break;
					case 13:buf[0] = '>';/* P */
							break;
					case 14:buf[0] = '=';/* M */
				}
			}
			pv_kput( (KANJI_PUT *)&font );
		}
	}
	return;
}
/*-----------------------------------------------------------*/
/*	 C					      							 */
/*-----------------------------------------------------------*/
int main(void)
{
	int bt;
	int ret;
	int FontNo[] = {
		0,1,2,3,4,5,6,7,8,9,
		10,11,12,16,17,19,20,24,25,26,
		32,33,40,41,48,49,50,56,57,58,
		59,60
		};/*@font_no :RQ */
	char buf[3]="  ";
	char buf0[1024],buf1[1024];
	int co = 0;

	KANJI_PUT mess = {{10,0},"font_code = ",0,0,0};
	KANJI_PUT dispno = {{82,0},buf,0,0,0};
	GVRAM_GET fontget[] = {
		{ {0,13,101,63},buf0 },
		{ {13,13,114,63},buf1 },
	};
	GVRAM_PUT fontput = { {0,13},0,0 };

	screen(1);						/*	̨Ӱ			*/
	gv_place(0,0);					/*	XYW@X:0, Y:0	*/
	endWaiting();					/*	NҰ݂̒~	*/
	cls(4);							/* 	ʃNA 			*/
	pv_kput( (KANJI_PUT *)&mess );
	INTtoASC( buf,FontNo[co],2,1 );
	pv_kput( (KANJI_PUT *)&dispno );
	/* ̫No\ */
	dispFont( FontNo[co] );
	/* ̫ĕ\ */
	while(1){
		bt = Keyin( (Key_up|Key_down),-1 );
/* Keyiñ{^ȊÕCxg */
		ret = EventCall(bt);
		if(ret == -1) {
			/* عݏIv */
			dos_exit(0);
		}
		else if( ret == 1 ) {
			ret = EventExec();
			if (ret == -1) {
				/* عݏIv */
				dos_exit(0);
			}
			/* EventExecŕ\Ă邽ߍĕ` */
			cls(4);							/* ʃNA */
			pv_kput( (KANJI_PUT *)&mess );
			INTtoASC( buf,FontNo[co],2,1 );
			pv_kput( (KANJI_PUT *)&dispno );
			/* ̫No\ */
			dispFont( FontNo[co] );
			/* ̫ĕ\ */
		}
/* ܂ */
/* {^̃Cxg */
		if( bt&Key_menu ){
			/* menuL[ŏI */
			dos_exit(0);
		}
		else if( bt&Key_up ){
			co ++;
			if( co > 31 )	co = 0;
			INTtoASC( buf,FontNo[co],2,1 );
			pv_kput( (KANJI_PUT *)&dispno );
			/* ̫No\ */
			dispFont( FontNo[co] );
			/* ̫ĕ\ */
			if( co >= 27 ){
				memset( buf0, 0, 1024 );
				memset( buf1, 0, 1024 );	/* ޯ̧ر	*/
				pv_get( (GVRAM_GET *)&fontget[0] );
				pv_get( (GVRAM_GET *)&fontget[1] );
			}
		}
		else if( bt&Key_down ){
			co --;
			if( co < 0 )	co = 31;
			INTtoASC( buf,FontNo[co],2,1 );
			pv_kput( (KANJI_PUT *)&dispno );
			/* ̫No\ */
			dispFont( FontNo[co] );
			/* ̫ĕ\ */
			if( co >= 27 ){
				memset( buf0, 0, 1024 );
				memset( buf1, 0, 1024 );	/* ޯ̧ر	*/
				pv_get( (GVRAM_GET *)&fontget[0] );
				pv_get( (GVRAM_GET *)&fontget[1] );
			}
		}
		else if( bt&Key_right ){
			if( co >= 27 ){
				/* Ȃ\ */
				fontput.buf = buf1;
				pv_put( (GVRAM_PUT *)&fontput );
			}
		}
		else if( bt&Key_left ){
			if( co >= 27 ){
				fontput.buf = buf0;
				pv_put( (GVRAM_PUT *)&fontput );
			}
		}
	}
}
/* ܂ */
