/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*																		*/
/*		WsOA[	 											*/
/*		psdos		     												*/
/*======================================================================*/

#include"lcdbios.h"
#include"wbios.h"
#include"psdos.h"
#include"rupsys.h"
#include"ruptool.h"

MENU Mp[] = {
	{ setBackMenu,"߂@@@@@@@",0,0},
	{ setExitMenu,"ع݂̏I   ",0,0}
};

/* tHg\ */
static int FONT0,X0,Y0,w0,h0,W0;


/****************  ǂɂ܂B ******************/
static void chkWALL( int wall0,int wall1, int *X, int *dX );
/****************      񌅕\       ******************/
/*static char *itoa2( int test, int zero );*/


typedef struct{
	int yy; int mm; int dd;
	int h;  int m;  int s;
} st_RTM;

/* tAԏ */
static st_RTM RTM;

/************* A^CNbN ************/
static void GetRTC(void)
{
/* t̎擾 */
    RTM.yy=pSystemCtl->CPUram->NOW_Year;
    RTM.mm=pSystemCtl->CPUram->NOW_Month;
    RTM.dd=pSystemCtl->CPUram->NOW_Day;

/* ̎擾 */
    RTM.h=pSystemCtl->CPUram->NOW_Hour;
    RTM.m=pSystemCtl->CPUram->NOW_Min;
    RTM.s=pSystemCtl->CPUram->NOW_Sec;
}

static char *itoa2( int test, int zero )
{
/* 񌅕\ */
    static char data[20];
    int ptr=0;

    if( test==0 )
	if( !zero ) return( "00" );
	else	    return( "?0" );

    if( test>=100 )
		test=test%100;
    else if( test>=10 ){
		data[ptr++]=0x30+test/10;
		test=test%10;
    }else{
		if( zero ) data[ptr++]='?';
		else	   data[ptr++]='0';
    }

    data[ptr++]=0x30+test;
    data[ptr]='\0';
    return( data );
}
static void saverDISP(int disp)
{
/* `FbN\ */
	static int pmin=-100;
    GetRTC();
	if (pmin!=RTM.m||disp) {
		pmin=RTM.m;
		gv_kput(150     ,150,"??:??",FONT0,0,0);
		gv_kput(150	,150,itoa2(RTM.h,1),FONT0,0,0);
		gv_kput(150+3*w0,150,itoa2(RTM.m,0),FONT0,0,0);
	}
}
/********************* WvZ **********************/
static int  GRAV; /* d */
static int  dy;   /* x y */
static int  dx;   /* x x */
/******************************************************/
static void saverPROC(void)
{
/* ړo[W */
	static int  px,py;
	px =X0;
	py =Y0;
	dy+=GRAV;	/* d͂̉Z */
	X0+=dx;
	Y0+=dy;

	/* wW`FbN */
	if( RTM.h>=10 )
		chkWALL(0   ,101-W0,&X0,&dx);
	else
		chkWALL(0-w0,101-W0,&X0,&dx);

	/* xW`FbN */
	chkWALL(0,63-h0,&Y0,&dy);

	/* ` */
	lcdfreeze(1);
	saverDISP(0);
	gv_place(150-X0,150-Y0);
	lcdfreeze(0);
}
/****************** ^C}[ꎞ~ **********************/
static void saverSTOP(int *TM)
{
	TM[0] = 0;
	cls(LCD_ERASE);
}
static void saverRESTART(int *TM)
{
	saverDISP(1);
	TM[0] = 1;
}
/****************** s[` **********************/
void SvExec(int *TM)
{
	int bt,rst;

	bt=rst=0;
	while (bt==0 && rst==0) {
		/* &ē͑҂ */
		bt = Keyin(0,-1);
		/* ĂmF */
		rst = EventCall(bt&~Bkey_A);

		if (rst == 1) {
			saverSTOP(TM);

			rst = EventExec();
			if (bt&Bkey_A)
				bt=0;

			saverRESTART(TM);
		}
		/* Keyin()ł́AELĂԂȂ */
		if (bi_scanbtn()&Bkey_C)
			bt=rst=0;
	}

}
void Exec(int *TM)
{
	int bt,rst;

	bt=rst=0;
	while(1) {
		bt=Keyin(0,-1);
		rst = EventCall(bt);

		if (rst==-1) {
			return;			/* عݏIv */
		}
		else if (rst==1) {
			saverSTOP(TM);

			rst = EventExec();
			if (rst==-1)
				return;		/* عݏIv */

			saverRESTART(TM);
		}
		else {
			if (bt==Bkey_D) {
				saverSTOP(TM);

				if((rst= aprMenu( "ެݸޱܰ",Mp,2 )) == -2)
					return;	/* عݏIv */

				saverRESTART(TM);
			}
/*****************
			else if (bi_scanbtn()&Bkey_C)
				bt=rst=0;	* Keyin()ł́AELĂԂȂ *
			else if (bt&0xFF)
				return;		* عݏIv *
******************/
		}
	}
}


int main(void)
{
	char *argv;
	int  *TMsvr=(int*)-1;
	int x,y;

	/* W擾 ruptool.h */
	getGvPos(&x,&y);

	/* ̎荞 */
	argv =getArg();
	/* ʂ̏ */
    screen(LCD_GRAPH);
	cls(LCD_ERASE);

	/* WvWv d3ň */
	GRAV=3;
	/* x̏ */
	dx=  2;
	dy=-11;
	FONT0=60;X0=13;Y0=40;w0=13;h0=24;W0=w0*5;

	/* \[`o^ */
	TMsvr=bi_tmset(1,255,1,saverPROC);

	if (pSystemCtl->EventManager->eventReq & EVENT_SvExec) {
		/* ܰގs */
		SvExec(TMsvr);
	} else {
		/* PɎs */
		Exec(TMsvr);
	}

	/* \[`I */
	if( TMsvr!=(int*)-1 )
		bi_tmdel(TMsvr);

	cls(LCD_ERASE);
	gv_place(x,y);	/* ̍Wɖ߂*/

}

/****************  ǂɂ܂B  ******************/
static void chkWALL( int wall0,int wall1, int *X, int *dX )
{
/* ǃ`FbN */
	if( *X<wall0 ){
	*X =2*wall0-(*X);
	*dX=-((*dX)+*X/10);
/*	*dX=-(*dX);
*/
	}else if( wall1<*X ){
	*X =2*wall1-(*X);
	*dX=-(*dX);
	}
}

