/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*                                                                      */
/*@\T		:	N  j ߑOߌ                           */
/*                                                                      */
/*======================================================================*/

#include "rupsys.h"

int convGnuToPanaxI4(int,int,int,int,int*);
int convGnuToPanaxI5(int,int,int,int,int,int*);
int convGnuToPanaxI7(int,int,int,int,int,int,int,int*);

/*
	CPUramj\
*/
void dispNowWeek( int x, int y, int font, int dot, int mode )
{
	convGnuToPanaxI5(x,y,font,dot,mode,
					(int*)pSystemCtl->dispRtcWeek);
}
/*
	CPUramN\
*/
void dispNowDate( int x, int y, int font, int dot, int YearNotDisp)
{
	convGnuToPanaxI5(x,y,font,dot,YearNotDisp,
					(int*)pSystemCtl->dispRtcDate);
}
/*
	CPUram`l/ol\
*/
void dispNowAmPm( int x, int y, int font, int dot )
{
	convGnuToPanaxI4(x,y,font,dot,
					(int*)pSystemCtl->dispRtcAmPm);
}
/*
	CPUram\
*/
int dispNowTime( int x1, int x2, int x3, int y, int font, int dot, int Alldisp)
{
	int rst;
	rst = convGnuToPanaxI7(x1,x2,x3,y,font,dot,Alldisp,
							(int*)pSystemCtl->dispRtcTime);
	return rst;
}
/*
	CPUramb\
*/
void dispNowSec( int x, int y, int font, int dot, int Alldisp)
{
	convGnuToPanaxI5(x,y,font,dot,Alldisp,
					(int*)pSystemCtl->dispRtcSec);
}

/*=================== GNUPanax ======================*/
/*                 WX^ϊ                    */
/*=====================================================*/
int convGnuToPanaxI4(int i0,int i1,int i2,int i3,int *func)
{
	/* 1WX^	GNU=D0,Panax=D0 		*/
	/* 2WX^	GNU=D1,Panax=D1 		*/
	/* 3WX^	GNU=A2+0(+4),Panax=A3+8 */
	/* 4WX^	GNU=A2+2(+4),Panax=A3+A */
	/* ֐Ăяo		A2+4(+4)  A1 			*/
	asm("
		add		-8,A3							#
		mov		A1,(0,A3)
		movx	D2,(4,A3)

		add		-0x0C,A3		#zPanaxX^bNm 4+4*2byte
			mov		D0,(0x04,A3)	#arg1ݒ
			mov		D1,(0x06,A3)	#arg2ݒ

			mov		(0x04,A2),D2
			mov		D2,(0x08,A3)	#arg3ݒ

			mov		(0x06,A2),D2
			mov		D2,(0x0A,A3)	#arg4ݒ

			mov		(0x08,A2),A1	#֐ݒ
			jsr		(A1)
		add		0x0C,A3			#zPanaxX^bN

		mov		(0,A3),A1
		movx	(4,A3),D2
		add		8,A3
	");
}
int convGnuToPanaxI5(int i0,int i1,int i2,int i3,int i4,int *func)
{
	/* 1WX^	GNU=D0,Panax=D0 		*/
	/* 2WX^	GNU=D1,Panax=D1 		*/
	/* 3WX^	GNU=A2+0(+4),Panax=A3+8 */
	/* 4WX^	GNU=A2+2(+4),Panax=A3+A */
	/* 5WX^	GNU=A2+4(+4),Panax=A3+C */
	/* ֐Ăяo		A2+6(+4)  A1 			*/
	asm("
		add		-8,A3							#
		mov		A1,(0,A3)
		movx	D2,(4,A3)

		add		-0x0E,A3		#zPanaxX^bNm 4+5*2byte
			mov		D0,(0x04,A3)	#arg1ݒ
			mov		D1,(0x06,A3)	#arg2ݒ

			mov		(0x04,A2),D2	#A2 +4(ret܂)
			mov		D2,(0x08,A3)	#arg3ݒ

			mov		(0x06,A2),D2
			mov		D2,(0x0A,A3)	#arg4ݒ

			mov		(0x08,A2),D2
			mov		D2,(0x0C,A3)	#arg5ݒ

			mov		(0x0A,A2),A1	#֐ݒ
			jsr		(A1)
		add		0x0E,A3			#zPanaxX^bN

		mov		(0,A3),A1
		movx	(4,A3),D2
		add		8,A3
	");
}
int convGnuToPanaxI7(int i0,int i1,int i2,int i3,
						int i4,int i5,int i6,int *func)
{
	/* 1WX^	GNU=D0,Panax=D0			*/
	/* 2WX^	GNU=D1,Panax=D1			*/
	/* 3WX^	GNU=A2+0(+4),Panax=A3+8	*/
	/* 4WX^	GNU=A2+2(+4),Panax=A3+A */
	/* 5WX^	GNU=A2+4(+4),Panax=A3+C */
	/* 6WX^	GNU=A2+6(+4),Panax=A3+E */
	/* 7WX^	GNU=A2+8(+4),Panax=A3+10*/
	/* ֐Ăяo		A2+A(+4)  A1			*/
	asm("
		add		-8,A3							#
		mov		A1,(0,A3)
		movx	D2,(4,A3)

		add		-0x12,A3		#zPanaxX^bNm 4+7*2byte
			mov		D0,(0x04,A3)	#arg1ݒ
			mov		D1,(0x06,A3)	#arg2ݒ

			mov		(0x04,A2),D2	#A2 +4(ret܂)
			mov		D2,(0x08,A3)	#arg3ݒ

			mov		(0x06,A2),D2
			mov		D2,(0x0A,A3)	#arg4ݒ

			mov		(0x08,A2),D2
			mov		D2,(0x0C,A3)	#arg5ݒ

			mov		(0x0A,A2),D2
			mov		D2,(0x0E,A3)	#arg6ݒ

			mov		(0x0C,A2),D2
			mov		D2,(0x10,A3)	#arg7ݒ

			mov		(0x0E,A2),A1	#֐ݒ
			jsr		(A1)
		add		0x12,A3			#zPanaxX^bN

		mov		(0,A3),A1
		movx	(4,A3),D2
		add		8,A3
	");
}
