/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*======================================================================*/

#include  "common.h"

/*======================================================================*/
/*֐	:fp_seg              										*/
/*																		*/
/*@\		:jAAhXZOgAhX߂@@ 			*/
/*																		*/
/*		:int fp_seg(void *)											*/
/*																		*/
/*		:jAAhX@@@@@@@@@@@@@@@	@			*/
/*																		*/
/*o		:Ȃ@@@@@@											*/
/*																		*/
/*߂l	:ZOgAhX@@@@@@@@@@@@@@@@@@		*/
/*																		*/
/*======================================================================*/
int fp_seg(void *seg)
{
	int		temp;
	long	addr;

	addr = (long)seg & 0xffffff;

	temp = (int)((addr >> 16) & 0x0000ff);
	return(temp);
}
/*======================================================================*/
/*֐	:fp_off              										*/
/*																		*/
/*@\		:jAAhXItZbgAhX߂@@@			*/
/*																		*/
/*		:int fp_off(void *)											*/
/*																		*/
/*		:jAAhX@@@@@@@@@@@@@@@	@			*/
/*																		*/
/*o		:Ȃ@@@@@@											*/
/*																		*/
/*߂l	:ItZbgAhX@@@@@@@@@@@@@@@@@@		*/
/*																		*/
/*======================================================================*/
int fp_off(void *offset)
{
	int 	temp;
	long	addr;

	addr = (long)offset & 0xffffff;

	temp = (int)(addr & 0x00ffff);
	return(temp);
}
/*======================================================================*/
/*֐	:linear              										*/
/*																		*/
/*@\		:ZOgEItZbg烊jAAhX߂ 			*/
/*																		*/
/*		:long linear(int, int)										*/
/*																		*/
/*		:ZOgAhXAItZbgAhX@@@	@			*/
/*																		*/
/*o		:Ȃ@@@@@@											*/
/*																		*/
/*߂l	:jAAhX@@@@@@@@@@@@@@@@@@@@		*/
/*																		*/
/*======================================================================*/
long linear(int seg, int offset)
{
	long	addr;
	long	temp;
	long	temp2;

	temp 	= (long)(seg & 0xffff);
	temp2 	= (long)(offset & 0xffff);

	addr	= (temp << 16) & 0xffff0000;
	addr	= addr | temp2;

	return(addr);
}
