/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*======================================================================*/

#if !defined(_LCDFUNC_)
#define _LCDFUNC_

/*===============================================================
=		@\ԍ`											=
===============================================================*/

#define		FNO_SCREEN			0					/* ʃ[hݒ				*/
#define		FNO_GETSCREEN		1					/* ʃ[h擾				*/
#define		FNO_CLS				2					/* ʃNA					*/
#define		FNO_LCDON			3					/* d					*/
#define		FNO_GETLCDON		4					/* dԎ擾				*/
#define		FNO_MOJISIZE		6					/* TCY擾				*/
#define		FNO_GETBUFSIZE		7					/* f[^TCYvZ				*/
#define		FNO_REVERSE			8					/* ẅ攽]					*/
#define		FNO_REVSTART		9					/* ]ꎞ~					*/
#define		FNO_REVSTOP			10					/* ]ĊJ						*/
#define		FNO_REVEND			11					/* ]I						*/
#define		FNO_REVDRAW			12					/* ]ĕ`					*/
#define		FNO_BLINK			13					/* ẅ_					*/
#define		FNO_BLSTOP			14					/* _ňꎞ~					*/
#define		FNO_BLSTART			15					/* _ōĊJ						*/
#define		FNO_BLEND			16					/* _ŏI						*/
#define		FNO_FREEZE			17					/* ʃt[Y				*/
#define		FNO_VOL				18					/* kbcdq{[ʐݒ	*/
#define		FNO_GETVOL			19					/* kbcdq{[ʎ擾	*/

#define		FNO_LC_KPUT			20					/* w蕶`				*/
#define		FNO_LC_SPUT			21					/* rhhVtgihr`		*/
#define		FNO_LC_APUT			22					/* tHgf[^`			*/
#define		FNO_LC_LINE			24					/* `						*/
#define		FNO_LC_SQUARE		25					/* ``					*/
#define		FNO_LC_CIRCLE		26					/* ~`						*/
#define		FNO_LC_PSET			27					/* _`						*/
#define		FNO_LC_POINT		28					/* _Ԏ擾					*/
#define		FNO_LC_GET			29					/* OtBbNp^[擾		*/
#define		FNO_LC_PUT			30					/* OtBbNp^[`		*/
#define		FNO_LC_REVERSE		31					/* [Nʎw攽]		*/
#define		FNO_LC_CLEAR		32					/* [NʎwNA		*/

#define		FNO_GV_PLACE		60					/* \ʒuw					*/
#define		FNO_GV_KPUT			61					/* w蕶`				*/
#define		FNO_GV_SPUT			62					/* rhhVtgihr`		*/
#define		FNO_GV_APUT			63					/* tHgf[^`			*/
#define		FNO_GV_LINE			65					/* `						*/
#define		FNO_GV_SQUARE		66					/* ``					*/
#define		FNO_GV_CIRCLE		67					/* ~`						*/
#define		FNO_GV_PSET			68					/* _`						*/
#define		FNO_GV_POINT		69					/* _Ԏ擾					*/
#define		FNO_GV_GET			70					/* OtBbNp^[擾		*/
#define		FNO_GV_PUT			71					/* OtBbNp^[`		*/
#define		FNO_GV_SCROLL		72					/* fuq`lXN[			*/
#define		FNO_GV_REVERSE		73					/* fuq`lw攽]		*/
#define		FNO_GV_CLEAR		74					/* fuq`lwNA		*/

/*===============================================================
=		e[uwb_[`									=
===============================================================*/

typedef struct {
	INT		func ;								/* @\ԍ					*/
} FNC_HEAD ;

/*===============================================================
=		screen֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			mode ;							/* [h					*/
} FNC_SCREEN ;

/*===============================================================
=		getscreen֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
} FNC_GETSCREEN ;

/*===============================================================
=		cls֐													=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			mode ;							/* [h					*/
} FNC_CLS ;

/*===============================================================
=		lcdon֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			power ;							/* dw				*/
} FNC_LCDON ;

/*===============================================================
=		getlcdon֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
} FNC_GETLCDON ;

/*===============================================================
=		mojisize֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			s_code ;						/* rhhVtgihrR[h	*/
} FNC_MOJISIZE ;

/*===============================================================
=		getbufsize֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
} FNC_GETBUFSIZE ;

/*===============================================================
=		reverse֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
} FNC_REVERSE ;

/*===============================================================
=		revstop֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			no ;							/* ]ԍ@			*/
} FNC_REVSTOP ;

/*===============================================================
=		revstart֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			no ;							/* ]ԍ@			*/
} FNC_REVSTART ;

/*===============================================================
=		revend֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			no ;							/* ]ԍ@			*/
} FNC_REVEND ;

/*===============================================================
=		revdraw֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
} FNC_REVDRAW ;

/*===============================================================
=		blink֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
	INT			color ;							/* _ŕ@w				*/
} FNC_BLINK ;

/*===============================================================
=		blstop֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			no ;							/* _ŋԍ@			*/
} FNC_BLSTOP ;

/*===============================================================
=		blstart֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			no ;							/* _ŋԍ@			*/
} FNC_BLSTART ;

/*===============================================================
=		blend֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			no ;							/* _ŋԍ@			*/
} FNC_BLEND ;

/*===============================================================
=		lcdfreeze֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			mode ;							/* [h					*/
} FNC_LCDFREEZE ;

/*===============================================================
=		lcdvol֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			vol ;							/* {[				*/
} FNC_VOL ;

/*===============================================================
=		getlcdvol֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
} FNC_GETVOL ;

/*===============================================================
=		lc_kput֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW				*/
	INT			y ;								/* xW				*/
	CHAR		*str ;							/* \				*/
	INT			size_code ;						/* TCYR[h				*/
	INT			dot ;							/* ԃhbg			*/
	INT			logic ;							/* _Zw				*/
} FNC_LCKPUT ;

/*===============================================================
=		lc_sput֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW				*/
	INT			y ;								/* xW				*/
	INT			s_code ;						/* rhhVtgihrR[h	*/
	INT			logic ;							/* _Zw				*/
} FNC_LCSPUT ;

/*===============================================================
=		lc_aput֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW				*/
	INT			y ;								/* xW				*/
	INT			w ;								/* hbg			*/
	INT			h ;								/* hbg			*/
	ULONG		add ;							/* tHgf[^AhX	*/
	INT			logic ;							/* _Zw				*/
} FNC_LCAPUT ;

/*===============================================================
=		lc_line֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
	INT			logic ;							/* _Z					*/
	UCHAR		style ;							/* CX^C			*/
	UCHAR		rsv ;							/* gp					*/
} FNC_LCLINE ;

/*===============================================================
=		lc_square֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
	INT			logic ;							/* _Z					*/
	ULONG		style ;							/* CX^C			*/
} FNC_LCSQUARE ;

/*===============================================================
=		lc_circle֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* SwW				*/
	INT			y ;								/* SxW				*/
	INT			xw ;							/* wa				*/
	INT			yw ;							/* xa				*/
	INT			d1x ;							/* Jn_wW				*/
	INT			d1y ;							/* Jn_xW				*/
	INT			d2x ;							/* I_wW				*/
	INT			d2y ;							/* I_xW				*/
	INT			logic ;							/* _Z					*/
	ULONG		style ;							/* CX^C			*/
	UCHAR		*cbuf ;							/* hԂp[N		*/
} FNC_LCCIRCLE ;

/*===============================================================
=		lc_pset֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW					*/
	INT			y ;								/* xW					*/
	INT			logic ;							/* _Z					*/
} FNC_LCPSET ;

/*===============================================================
=		lc_point֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW					*/
	INT			y ;								/* xW					*/
} FNC_LCPOINT ;

/*===============================================================
=		lc_get֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
	CHAR		*buf ;							/* i[obt@				*/
} FNC_LCGET ;

/*===============================================================
=		lc_put֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW				*/
	INT			y ;								/* xW				*/
	CHAR		*buf ;							/* i[obt@				*/
	INT			logic ;							/* _Z					*/
} FNC_LCPUT ;

/*===============================================================
=		lc_reverse֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
} FNC_LCREV ;

/*===============================================================
=		lc_clear֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
} FNC_LCCLR ;

/*===============================================================
=		gv_place֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW				*/
	INT			y ;								/* xW				*/
} FNC_GVPLACE ;

/*===============================================================
=		gv_kput֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW				*/
	INT			y ;								/* xW				*/
	CHAR		*str ;							/* \				*/
	INT			size_code ;						/* TCYR[h				*/
	INT			dot ;							/* ԃhbg			*/
	INT			logic ;							/* _Zw				*/
} FNC_GVKPUT ;

/*===============================================================
=		gv_sput֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW				*/
	INT			y ;								/* xW				*/
	INT			s_code ;						/* rhhVtgihrR[h	*/
	INT			logic ;							/* _Zw				*/
} FNC_GVSPUT ;

/*===============================================================
=		gv_aput֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW				*/
	INT			y ;								/* xW				*/
	INT			w ;								/* hbg			*/
	INT			h ;								/* hbg			*/
	ULONG		add ;							/* tHgf[^AhX	*/
	INT			logic ;							/* _Zw				*/
} FNC_GVAPUT ;

/*===============================================================
=		gv_line֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
	INT			logic ;							/* _Z					*/
	UCHAR		style ;							/* CX^C			*/
	UCHAR		rsv ;							/* gp					*/
} FNC_GVLINE ;

/*===============================================================
=		gv_square֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
	INT			logic ;							/* _Z					*/
	ULONG		style ;							/* CX^C			*/
} FNC_GVSQUARE ;

/*===============================================================
=		gv_circle֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* SwW				*/
	INT			y ;								/* SxW				*/
	INT			xw ;							/* wa				*/
	INT			yw ;							/* xa				*/
	INT			d1x ;							/* Jn_wW				*/
	INT			d1y ;							/* Jn_xW				*/
	INT			d2x ;							/* I_wW				*/
	INT			d2y ;							/* I_xW				*/
	INT			logic ;							/* _Z					*/
	ULONG		style ;							/* CX^C			*/
	UCHAR		*cbuf ;							/* hԂp[N		*/
} FNC_GVCIRCLE ;

/*===============================================================
=		gv_pset֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW					*/
	INT			y ;								/* xW					*/
	INT			logic ;							/* _Z					*/
} FNC_GVPSET ;

/*===============================================================
=		gv_point֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW					*/
	INT			y ;								/* xW					*/
} FNC_GVPOINT ;

/*===============================================================
=		gv_get֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
	CHAR		*buf ;							/* i[obt@				*/
} FNC_GVGET ;

/*===============================================================
=		gv_put֐												=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x ;								/* wW				*/
	INT			y ;								/* xW				*/
	CHAR		*buf ;							/* i[obt@				*/
	INT			logic ;							/* _Z					*/
} FNC_GVPUT ;

/*===============================================================
=		gv_scroll֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			lines ;							/* C					*/
} FNC_GVSCROLL ;

/*===============================================================
=		gv_reverse֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
} FNC_GVREV ;

/*===============================================================
=		gv_clear֐											=
===============================================================*/

typedef struct {
	FNC_HEAD	head ;							/* e[uwb_[			*/
	INT			x1 ;							/* wW				*/
	INT			y1 ;							/* xW				*/
	INT			x2 ;							/* EwW				*/
	INT			y2 ;							/* ExW				*/
} FNC_GVCLR ;

#endif
