/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*======================================================================*/

#include		"lcdlib.h"
#include		"lcdfunc.h"

/*===================================================================================
=	lc_square			``
=
=	yďo`z	INT  lc_square( INT x1, INT y1, INT x2, INT y2,
=										  			   INT logic, ULONG style)
=
=	ýz		INT		x1 ;		Jn_̂wW
=					INT		y1 ;		Jn_̂xW
=					INT		x2 ;		I~_̂xW
=					INT		y2 ;		I~_̂xW
=					INT		logic ;		_Z
=					ULONG	style ;		CX^C
=
=	y^[lz	INT		ret ;		_OK  : I
=										_ERR : p[^G[
=
=	yez
=
===================================================================================*/

INT lc_square( INT x1, INT y1, INT x2, INT y2, INT logic, ULONG style)
{
	LONG			ret ;
	FNC_LCSQUARE	ftbl;

	ftbl.head.func = FNO_LC_SQUARE ;
	ftbl.x1    = x1 ;
	ftbl.y1    = y1 ;
	ftbl.x2    = x2 ;
	ftbl.y2    = y2 ;
	ftbl.logic = logic ;
	ftbl.style = style ;

	ret = lcdcall( &ftbl) ;

	return( ( INT)ret) ;
}
