/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*======================================================================*/

#include <stdio.h>
#include <string.h>

#define SNDFILENAMESIZE	8
#define PATHSIZE		32
typedef struct {
	unsigned short year;
	unsigned short month;
	unsigned short day;
	unsigned short hour;
	unsigned short min;
	char snd[SNDFILENAMESIZE];
	char exf[PATHSIZE];
} EVENTTABLE;

void main(int argc,char *argv[])
{
	FILE *fp;
	EVENTTABLE ev;

/* XPW[A[ ̎擾     */
	if (!(fp = fopen("ALARM.INI","rb"))) return;
	fread(&ev,1,sizeof(EVENTTABLE),fp);
	fclose(fp);

	if (!(fp = fopen("ALARM.INI","wb"))) return;

/* XPW[A[                */
	fwrite(&ev,1,sizeof(EVENTTABLE),fp);

/* [UA[1                     */
/* A[ 1998.10.28 AM9:00      */
/* TEh   BIRTH.snd              */
/* sAv   B:\MYPROG\BIRTHDAY.exf */
	ev.year  = 1998;
	ev.month = 10;
	ev.day   = 28;
	ev.hour  =  9;
	ev.min   =  0;
	memset(ev.snd,0,SNDFILENAMESIZE);
	memcpy(ev.snd,"BIRTH",sizeof("BIRTH"));
	memset(ev.exf,0,PATHSIZE);
	memcpy(ev.exf,"B:\\MYPROG\\BIRTHDAY.EXF",sizeof("B:\\MYPROG\\BIRTHDAY.EXF"));
	fwrite(&ev,1,sizeof(EVENTTABLE),fp);

/* [UA[2                     */
/* A[ 1998.7.24 PM11:00      */
/* TEh   ALARM2.snd             */
/* sAv   B:\MYPROG\R.exf */
	ev.year  = 1998;
	ev.month = 7;
	ev.day   = 24;
	ev.hour  = 23;
	ev.min   =  0;
	memset(ev.snd,0,SNDFILENAMESIZE);
	memcpy(ev.snd,"ALARM2",sizeof("ALARM2"));
	memset(ev.exf,0,PATHSIZE);
	memcpy(ev.exf,"B:\\MYPROG\\R.EXF",sizeof("B:\\MYPROG\\R.EXF"));
	fwrite(&ev,1,sizeof(EVENTTABLE),fp);

/* [UA[3                     */
/* A[ 1999.1.1 AM0:00        */
/* TEh   ALARM4.snd             */
/* sAv   B:\MYPROG\NEWYEAR.exf  */
	ev.year  = 1999;
	ev.month = 1;
	ev.day   = 1;
	ev.hour  = 0;
	ev.min   = 0;
	memset(ev.snd,0,SNDFILENAMESIZE);
	memcpy(ev.snd,"ALARM4",sizeof("ALARM4"));
	memset(ev.exf,0,PATHSIZE);
	memcpy(ev.exf,"B:\\MYPROG\\NEWYEAR.EXF",sizeof("B:\\MYPROG\\NEWYEAR.EXF"));
	fwrite(&ev,1,sizeof(EVENTTABLE),fp);

	fclose(fp);
}
