/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*																		*/
/*		AD2COM3 dr												*/
/*		        												*/
/*======================================================================*/

#include<stdio.h>	/* CWײ sprintf */
#include<string.h>	/* CWײ strcpy */

#include"wbios.h"
#include"psdos.h"
#include"lcdbios.h"
#include"rupsys.h"	/* Ruputerͯ Bkey_**  */


/* MAIN.C Ŏg֐̃vg^Cv錾 */
void PwreadProc(int);			/* {̂main()̉ɂ܂ */
void ComProc(int);				/* {̂main()̉ɂ܂ */
void MessSend(char*,int);		/* {̂main()̉ɂ܂ */

int main(void)
{
    screen(1);

	cls(4);

	gv_kput(10,10,"ð݂ɏ悹 ",0,0,0);
	gv_kput(10,22,"         ",0,0,0);

	while( !(bi_getbtn()&Bkey_SH) ){}	/* Rs232cّ}҂ */
	cls(4);

	/* ӰĒʐM */
	ComProc(4);	/* ްڰ 4: 19.2kbps ̈ɂύX\ */
	lcdon(1);

    while( !(bi_getbtn()&Bkey_D) ){}	/* ƭŏI */

	gv_place(0,0);
	cls(4);
    gv_kput(0,2,"̌",0,0,0);
    gv_kput(30,40,"łH",0,0,0);
    cls(4);
}

void ComProc(int Bps)
{
	/* Bps:ްڰĂ̂ݐݒ\ */
	const int Dev=2;	/* Rs232c */
	const int Pulse=0;	/* ԊOٽARs232cł͓ɈӖȂ */
	const int Tout=10;	/* ѱĎ */

	/* ʐM */
	if( bi_cominit(Dev,Bps,Pulse,Tout) ){
		gv_kput(10,10,"ʐMNG ",0,0,0);
	}
	else if( bi_comclr() ){
		gv_kput(10,10,"ޯ̧NG",0,0,0);
	}
	else if( bi_comopen() ){
		gv_kput(10,10,"ڑ NG      ",0,0,0);
	}
	else{
		/* ʐM ڑ OK */
		gv_kput(10,10,"ڑ OK      ",0,0,0);

		/* M */
		PwreadProc( Tout ); /* ʐMG[(rs232cؒf)Ŗ߂܂ */

		/* ʐM ؒf */
		if( bi_comclose() ){
			gv_kput(10,10,"ؒf NG        ",0,0,0);
		}
		if( bi_cominit(0,0,0,0) ){
			gv_kput(10,10,"ʐMI NG    ",0,0,0);
		}
		else{
			gv_kput(10,10,"ʐMI       ",0,0,0);
		}
	}
}

#define TIMEOUT_ERR 0x10
void PwreadProc(int Tout)
{
	int Key=0;
	int i=1,count;
	char buff[32];
	char read[8];
	int	volt;

	while( !(Key&Bkey_D) ){

		/* M֐gp 1޲Ď擾 */
		if( bi_complreadn(read,1,&count) ){
			if( BIOSerr&~TIMEOUT_ERR ){
				gv_kput(10,49,"Mװ",0,0,0);
				Key=Bkey_D;
			}
			else{
				sprintf(buff,":%3db",i*Tout);
				gv_kput(10,10,buff,0,0,0);
				i++;
			}
		}
		else{
			/* 1޲Ď擾 */

			strcpy(buff,":");
			for(i=0;i<count;i++){
				sprintf(buff,"%s%02Xh ",buff,read[i]&0xFF);
			}
			gv_kput(10,10,buff,0,0,0);
			switch( read[0] ){
			  case '8':
				lcdon(1);				/* LCDײON */
				MessSend("LCD ON\n\r",8);
				break;
			  case '2':
				lcdon(0);				/* LCDײOFF */
				MessSend("LCDOFF\n\r",8);
				break;
			  case '4':
				volt = bi_powerread();	/* dǍ */

				if( (unsigned int)volt<=255 ){
					sprintf(buff,"P0=%03d\n\r",(unsigned int)volt);	/* ϊ */
				}else{
					strcpy(buff,"VOLERR\n\r");
				}
				MessSend(buff,8);

				if( getlcdon() ){
					/* LCDʂɕ\ */
					buff[6]='\0';
					gv_kput(10,25,buff,2,0,0);
				}
				break;
			  case '6':
				volt = bi_powerread2();	/* d2Ǎ */

				if( (unsigned int)volt<=255 ){
					sprintf(buff,"P2=%03d\n\r",(unsigned int)volt);	/* ϊ */
				}else{
					strcpy(buff,"VOLERR\n\r");
				}
				MessSend(buff,8);

				if( getlcdon() ){
					/* LCDʂɕ\ */
					buff[6]='\0';
					gv_kput(10,37,buff,2,0,0);
				}
				break;
			}
			i=1;		/* ѱĉ񐔂ؾ */
			bi_comclr();/* Mޯ̸̧ر */
		}
		bi_clrbtn();
	}
}
void MessSend(char *write,int len)
{
	/* Ƃ肠AƂ len޲ Ԃ܂B */
	int  ret,num;

	if( ret=bi_complwrite(write,len,&num) ){
		if( ret==-2 ){
			gv_kput(10,10,"dG[",0,0,0);
		}
		else{
			gv_kput(10,49,"MG[",0,0,0);
		}
	}
}

