/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*																		*/
/*		Welcom to Ruputer Park											*/
/*		File        												*/
/*======================================================================*/

#include<string.h>
#include"wbios.h"	/* bios */
#include"lcdbios.h"	/* LCD` */

int main(void)
{
	int Key=0;
	char filename[80];
	int fp,ret;
	unsigned int Melody[1024];
	unsigned long len;

    screen(1);
	cls(4);

	/* ̏ 0xFFFFɂ */
	memset( &Melody, 0xFFFF, sizeof( Melody ) );
	/* t@C̐ݒ */
	strcpy(filename,"J.SND");

	if( CheckVol() ){/* dO`FbN */
		dispVOLerr();
		dos_exit(0);
	}

	/* t@C[h[hŊJ */
	if( ( fp = dos_fopen( filename, 0 ) ) <0 ) {
		gv_kput(0,20,"J.SND Open NG",0,0,0);
	}
	else {
		/* t@C擾 */
		len = dos_fseek( fp, 2, 0 );
		if( len > 1024 ) len = 1024;

		/* 擪obt@ɓ] */
		dos_fseek( fp, 0, 0 );
		ret = dos_fread( fp, (char *)Melody, (int)len );

		if (ret==len)
			gv_kput(0,20,"Jsnd t",0,0,0);
		else
			gv_kput(0,20,"Ǎُ݈",0,0,0);

		/* t@C */
		dos_fclose( fp );

		/* 炷 */
		bi_canmelody();/* ~ */
		bi_buzzinit( Melody[0], Melody[1] );
		bi_melody( &Melody[2] );

	}

	/* t@C݂܂B */
	/* t@C̐ݒ */
	strcpy(filename,"VK.SND");

	if( CheckVol() ){/* dO`FbN */
		dispVOLerr();
		dos_exit(0);
	}
	if (dos_freespace(len)) {/* I[o[̃`FbN */
		dispMEMORYerr();
		dos_exit(0);
	}

	/* t@CVK쐬 ɂꍇ̓G[ŏI */
	if ( (fp = dos_fcrnew( filename )) <0 ) {
		gv_kput(0,20,"VK.SND Open NG",0,0,0);
	}
	else {
		/* t@C */
		if ( (ret = dos_fwrite(fp,(char*)&Melody,len)) <0 ) {
			gv_kput(0,20,"VK.SND Write NG",0,0,0);

			/* t@C */
			dos_fclose( fp );

			/* tbṼtbV */
			bi_vwrflush();

			bi_canmelody();/* ~ */
			dos_exit(0);
		}

		/* t@C݊mF */
		if (ret==len)
			gv_kput(10,33,"ݏI",0,0,0);
		else
			gv_kput(10,33,"t",0,0,0);

		/* t@C */
		gv_kput(10,46,"Ă܂",0,0,0);
		dos_fclose( fp );

		/* tbṼtbV */
		gv_kput(10,46,"tbV",0,0,0);
		bi_vwrflush();
	}

	gv_kput(0,46,"L[ŏI",0,0,0);

	bi_getbtn();
	bi_getbtn();

	bi_canmelody();/* ~ */
	bi_clrbtn();
    cls(4);
}
