/*======================================================================*/
/*vWFNg:RUPUTER												*/
/*		Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*																		*/
/*		Ruputer۸ 											*/
/*		<<޼َv>>	   												*/
/*		װѐݒ					 									*/
/*======================================================================*/

#include "string.h"
#include "psdos.h"
#include "lcdbios.h"
#include "wbios.h"
#include "rupsys.h"
#include "font.h"

/* ݏdefine	*/
#define Key_file		0x0001		/*	swA(K0)荞	*/
#define Key_enter		0x0008		/*	swB(K3)荞	*/
#define Key_el			0x0004		/*	swC(K2)荞	*/
#define Key_menu		0x0002		/*	swD(K1)荞	*/
#define Key_left		0x0010		/*	swE(K4)荞	*/
#define Key_up			0x0020		/*	swF(K5)荞	*/
#define Key_right		0x0040		/*	swG(K6)荞	*/
#define Key_down		0x0080		/*	swH(K7)荞	*/

typedef struct{
	short DISPno;
	short Chaim;
	short ALmode[4];
	unsigned short ALweek[4];
}WATCH;
typedef struct{
	short hour;
	short min;
	short sec;
	short type;	/*	0:12h 1:24h	*/
}TIME;

static TIME alTM;
static WEEKLYTABLE ALdata[4];
static WATCH WTini;
static char Sndfile[32][9];
static TIME weekalTM;
static int sndMAX;
static int f_SOUSA;

const static RECT CLRLCD={0,0,101,63};
static KANJI_PUT AlarmModePut[]={
	{{72,0},"nee@",4,1,0},
	{{72,0},"c`x@",4,1,0},
	{{72,0},"vddj",4,1,0}
};
static GVRAM_PUT MMPput[]={
	{{97,26},(char *)mmpRYAs,0},
	{{25,41},(char *)mmpWEEK,0},
	{{0,53},(char *)mmpALARM,0}
};
/*-----------------------------------------------------------*/
/*	 l𱽷ނɕϊ(scosiiގgp)					 */
/*-----------------------------------------------------------*/
void INTtoASC(char *p,int val,int keta,int sup)
{
	int i;

	for(p[keta]='\0',i=keta-1;0<=i;i--){
		p[i]=val%10+0x30;
		if(i!=keta-1 && sup==1 && p[i]=='0')	p[i]='?';
		val /= 10;
	}
	return;
}
/*-----------------------------------------------------------*/
/*	 ݒ莞Ԃ̕\											 */
/*-----------------------------------------------------------*/
void dispSetTime(TIME *TM,KANJI_PUT *XY)
{
	int HourDATA;
	char buf[3];
	int fAMorPM=0;

	HourDATA=TM->hour;
	if( !(pSystemCtl->RupDefine->ClockType) ){/* vǂݍ */
		if(HourDATA>12){/*	AMPM_fAMorPM 1:PM  0:AM	*/
			HourDATA-=12;
			fAMorPM=1;
		}
		else if(HourDATA==12)	fAMorPM=1;
		else if(HourDATA==0)	HourDATA=12;
		if(fAMorPM)		XY[0].str=">=";/* PM */
		else			XY[0].str="<=";/* AM */
		pv_kput((KANJI_PUT *)&XY[0]);
	}
	INTtoASC(buf,HourDATA,2,1);
	XY[1].str=buf;
	pv_kput((KANJI_PUT *)&XY[1]);	/*\*/
	XY[2].str=":";
	pv_kput((KANJI_PUT *)&XY[2]);	/*F\*/
	INTtoASC(buf,TM->min,2,0);
	XY[3].str=buf;
	pv_kput((KANJI_PUT *)&XY[3]);	/*\*/
	return;
}
/*-----------------------------------------------------------*/
/*	 ̧ق̎擾										 */
/*-----------------------------------------------------------*/
/*	擾SNḐِ͍ő32̧ق܂	*/
static int GetSndFileName( char sndfile[32][9] )
{
	char DTA[44];
	int i,n;

	n =0;
	dos_setdta( DTA );		/*	DTA̐ݒ	*/
	if(!dos_fnd_first("B:\\SYSTEM\\SOUND\\*.snd",0x3f)){
		for( i = 31; DTA[i] && i < 39; i ++ ){
			 if( DTA[i] == '.' ) break;
		}
		strncpy( (char *)&sndfile[0], &DTA[31], i-31 );
		sndfile[0][i-31] = '\0';
		for( n=1; ( !dos_fnd_next() ) && n < 32; n++ ){
			for( i = 31; DTA[i] && i < 39; i ++ ){
				 if( DTA[i] == '.' ) break;
			}
			strncpy( (char *)&sndfile[n], &DTA[31], i-31 );
			sndfile[n][i-31] = '\0';
		}
	}
	return n;	/*	擾ِ̧Ԃ	*/
}
/*-----------------------------------------------------------*/
/*	 A[TEhf									 */
/*-----------------------------------------------------------*/
static unsigned int Melody[256];
static void alsoundDEMO( char *snd )
{
	long ms;
	int fp;
	char rFile[30] = SOUNDPATH;

	if( CheckVol() ){/* dO`FbN */
		dispVOLerr();
		dos_exit(0);
	}
	memset( &Melody, 0, sizeof( Melody ) );
	strcat( rFile, snd );
	strcat( rFile, ".SND" );
	if( ( fp = dos_fopen( rFile, 0 ) ) == -1 ) return;
	ms = dos_fseek( fp, 2, 0 );
	if( ms > 512 ) ms = 512;
	dos_fseek( fp, 0, 0 );
	dos_fread( fp, (char *)Melody, (int)ms );
	Melody[255] = 0xffff;/* 512byteވȏ̻ޑΉ */
	dos_fclose( fp );
	bi_canmelody();/* ~ */
	memcpy( pSystemCtl->MelodyPlay, Melody, ms );
	bi_buzzinit( pSystemCtl->MelodyPlay[0], pSystemCtl->MelodyPlay[1] );
	bi_melody( &pSystemCtl->MelodyPlay[2] );
	return;
}
/*-----------------------------------------------------------*/
/*	 }[N̕\								 */
/*-----------------------------------------------------------*/
static void disp_ALmark(int DT,int Mode)
{
	const GVRAM_PUT GARA[]={
		{{0,26},(char *)mmpGARA,3},
		{{0,39},(char *)mmpGARA,3},
		{{0,52},(char *)mmpGARA,3}
	};
	RECT CLRmmp={0,52,0,62};
	int k,i;

	switch(Mode){	/* ذװϰ\@*/
		case 0:	/* OFF@*/
			for(i=0;i<7;i++){
				CLRmmp.x1=26+i*10;
				CLRmmp.x2=33+i*10;
				pv_clear((RECT *)&CLRmmp);
			}
			for(i=0;i<3;i++){
				pv_put((GVRAM_PUT *)&GARA[i]);	/*	gps̍ږԊ|	*/
				gv_line(0,51,101,51,3,0xaa);
			}
			break;
		case 1:	/* DAYLY@*/
			for(i=0;i<7;i++){
				MMPput[2].pos.x=27+i*10;
				pv_put((GVRAM_PUT *)&MMPput[2]);/*ذװϰ\*/
			}
			break;
		case 2:	/* WEEKLY	*/
			for(i=0,k=0x01;i<7;i++,k*=2){
				if(!(DT&k)){/*off*/
					CLRmmp.x1=26+i*10;
					CLRmmp.x2=33+i*10;
					pv_clear((RECT *)&CLRmmp);
				}
				else{		/*on*/
					MMPput[2].pos.x=27+i*10;
					pv_put((GVRAM_PUT *)&MMPput[2]);/*ذװϰ\*/
				}
			}
	}
	return;
}
/*-----------------------------------------------------------*/
/*	 ̕\												 */
/*-----------------------------------------------------------*/
static void dispYA(int csr,int Mode)
{
	SIICODE_PUT YAput[]={
		{{13,13},0,0},/* iږW */
		{{13,26},0,0},/* iږW */
		{{13,52},0,0} /* OiږW */
	};

	if(0<=csr && csr<=3){		/*	ق̈ʒui	*/
		if(csr==0)		YAput[0].code=picRYAB;
		else			YAput[0].code=picLYAB;	/**/
		pv_sput((SIICODE_PUT *)&YAput[0]);
		YAput[1].code=picRYAW;					/**/
		pv_sput((SIICODE_PUT *)&YAput[1]);
		if(Mode==2){/* WEEKLY */
			YAput[2].code=picRYAW;				/**/
			pv_sput((SIICODE_PUT *)&YAput[2]);
		}
		else{
	 		gv_kput(0,52,"@@",0,0,0);
		}
	}
	else if(4<=csr && csr<=5){	/*	ق̈ʒui	*/
		YAput[0].code=picRYAW;					/**/
		pv_sput((SIICODE_PUT *)&YAput[0]);
		if(csr==4)		YAput[1].code=picRYAB;
		else			YAput[1].code=picLYAB;	/**/
		pv_sput((SIICODE_PUT *)&YAput[1]);
		if(Mode==2){/* WEEKLY */
			YAput[2].code=picRYAW;				/**/
			pv_sput((SIICODE_PUT *)&YAput[2]);
		}
	}
	else if(6<=csr){			/*	ق̈ʒuOi	*/
		YAput[0].code=picRYAW;					/**/
		pv_sput((SIICODE_PUT *)&YAput[0]);
		YAput[1].code=picRYAW;					/**/
		pv_sput((SIICODE_PUT *)&YAput[1]);
		if(Mode==2){/* WEEKLY */
			if(csr==6)	YAput[2].code=picRYAB;
			else		YAput[2].code=picLYAB;	/**/
			pv_sput((SIICODE_PUT *)&YAput[2]);
		}
	}
	return;
}
/*-----------------------------------------------------------*/
/*	 A[ڍאݒ										 */
/*-----------------------------------------------------------*/
static char *ALMENU[]={
		"װтPch",
		"װтQch",
		"װтRch",
		"װтSch",
};
static const char *SndFileErr[]={"@ݒ肳ꂽ","@̧ق","@܂"};
static const char *SndNoFileErr[]={" ̧ق"," ܂"};
void weeklyal( int csr )
{
	WEEKLYTABLE ALdataAL;
	WATCH WTiniAL;
	static int BLINK_no[14];
	int ALCH=csr/4;
	int	bt,ret;
	int cansel;
	int i,k;
	int weekcsr;
	int sndNo;
	int f_SOUSAL;
	int REPkey=(Key_up|Key_down);
	const BLINK_DRAW alBLINK[]={
		{{1,13, 12,24},0x00a0},	/*	ACRP	*/
		{{39,13, 49,24},0x00a0},/*		*/
		{{57,13, 67,24},0x00a0},/*		*/
		{{72,13, 94,24},0x00a0},/*	*/
		{{ 1,26, 12,37},0x00a0},/*	ACRQ	*/
		{{25,26,75,37},0x00a0},	/*	TEh	*/
		{{ 1,52, 12,63},0x00a0},/*	ACRR	*/
		{{26,42, 34,50},0x00a0},/*	EB[N[	*/
		{{36,42, 44,50},0x00a0},/*	EB[N[	*/
		{{46,42, 54,50},0x00a0},/*	EB[N[	*/
		{{56,42, 64,50},0x00a0},/*	EB[N[	*/
		{{66,42, 74,50},0x00a0},/*	EB[N[	*/
		{{76,42, 84,50},0x00a0},/*	EB[N[y	*/
		{{86,42, 94,50},0x00a0}	/*	EB[N[	*/
	};
	const SIICODE_PUT PICput[]={
		{{1,13},picCLOCK,0},
		{{1,26},picMELODY2,0},
		{{1,52},picWEEKLY,0},
		{{86,26},picMELODY,0}
	};
	SIICODE_PUT YAput[]={
		{{13,13},picRYAB,0},
		{{13,13},picLYAB,0},
	};
	const KANJI_PUT AlarmModePut[]={
		{{72,17},"nee@",4,1,0},
		{{72,17},"c`x@",4,1,0},
		{{72,17},"vddj",4,1,0}
	};
	KANJI_PUT dispALTIME[]={
			{{25,17},0,12,1,0},		/*	AM/PM	*/
			{{39,14},0,19,1,0},		/*		*/
			{{51,14},0,19,1,0},		/*	F	*/
			{{57,14},0,19,1,0},		/*		*/
	};
	KANJI_PUT SNDname[]={
		{{25,26},0,0,0,0},
		{{25,26},"Ȃ@@ ",0,0,0},
		{{25,26},"@@@@ ",0,0,0}
	};
	int SndFileOK;

	f_SOUSAL = 0;
	weekcsr = 0;
	WTiniAL = WTini;
	ALdataAL = ALdata[ALCH];
	if( ALdataAL.snd[0] ){
		SndFileOK = 0;
		for( i = 0; i < sndMAX; i ++ ){
			if( !strncmp( Sndfile[i], ALdataAL.snd, 8 ) ){
				sndNo = i;
				SndFileOK = 1;
				break;
			}
		}
		if( !SndFileOK ){/* ݒ軳ٌ̧Ȃ */
			if( WTiniAL.ALmode[ALCH] ){
				if( dispMess( (char **)SndFileErr, 3 )==-1 )	dos_exit(0);
			}
			/* IɱװOFF */
			ALdataAL.snd[0] = '\0';
			sndNo = 0;
			WTiniAL.ALmode[ALCH] = 0;
			f_SOUSAL = 1;
		}
	}
	else{/* װіݒ */
		sndNo = 0;
	}
	while(1){
		pv_clear((RECT *)&CLRLCD);
		lcdfreeze(1);
		for(i=0;i<14;i++){
			BLINK_no[i]=pblink((BLINK_DRAW *)&alBLINK[i]);
			blstop(BLINK_no[i]);
		}
		dispTitle(ALMENU[ALCH]);
		for(i=0;i<4;i++){
			pv_sput((SIICODE_PUT *)&PICput[i]);
		}
		pv_put((GVRAM_PUT *)&MMPput[0]);	/*	E	*/
		dispYA(weekcsr,WTiniAL.ALmode[ALCH]);/*@ACR\*/
		weekalTM.hour=ALdataAL.hour;
		weekalTM.min=ALdataAL.min;
		dispSetTime(&weekalTM,(KANJI_PUT *)&dispALTIME);/*ԕ\*/
		pv_kput((KANJI_PUT *)&AlarmModePut[WTiniAL.ALmode[ALCH]]);
		pv_put((GVRAM_PUT *)&MMPput[1]);	/* ذް\@\ */
		if( sndMAX ){
			SNDname[0].str=Sndfile[sndNo];
			pv_kput((KANJI_PUT *)&SNDname[0]);/*̧ٕ\*/
		}
		else	pv_kput((KANJI_PUT *)&SNDname[1]);	/*̧قȂ*/
		disp_ALmark(WTiniAL.ALweek[ALCH],WTiniAL.ALmode[ALCH]);
											/* ذװϰ\@*/
		lcdfreeze(0);
		blstart(BLINK_no[weekcsr]);

		while(1){
			bt=Keyin(REPkey,BLINK_no[weekcsr]);
			bt&=~Key_file;
			ret = EventCall(bt);
			if (ret == -1) {
				/* عݏIv */
				for( i=0;i<14;i++ )		blend(BLINK_no[i]);/*	blink	*/
				dos_exit(1);
			}
			else if (ret == 1) {
				for( i=0;i<14;i++ )		blend(BLINK_no[i]);/*	blink	*/
				ret = EventExec();
				if (ret == -1) {
					/* عݏIv */
					dos_exit(1);
				}
				break;
			}
			if(bt==Key_enter){
				if(weekcsr==0||weekcsr==4||weekcsr==6){
					for( i=0;i<14;i++ )		blend(BLINK_no[i]);/*	blink	*/
					WTini = WTiniAL;
					ALdata[ALCH] = ALdataAL;
					f_SOUSA |= f_SOUSAL;
					return;
				}
				else{
					blstop(BLINK_no[weekcsr]);
					if(0<weekcsr&&weekcsr<4)		weekcsr=0;
					else if(weekcsr==5)				weekcsr=4;
					else if(6<weekcsr)				weekcsr=6;
					if(WTiniAL.ALmode[ALCH]==0 && weekcsr==0){
						pv_sput((SIICODE_PUT *)&YAput[0]);
					}
					else dispYA(weekcsr,WTiniAL.ALmode[ALCH]);/*@ACR\*/
					blstart(BLINK_no[weekcsr]);
				}
			}
			else if(bt==Key_menu){
				for( i=0;i<14;i++ )		blend(BLINK_no[i]);/*	blink	*/
				if(	f_SOUSAL ){
					cansel=dispCancelYN();			/*	ݒ̷ݾ	*/
					if( cansel == -1 ) 	dos_exit(0);
					if( cansel )		break;		/*	ݾNOȂ畜A	*/
				}
				return;
			}
			else if(bt==Key_up){
				if(weekcsr==4||weekcsr==6){	/*ق݂̈ʒuɂꍇ*/
					blstop(BLINK_no[weekcsr]);
					if(weekcsr==6)	weekcsr=4;
					else			weekcsr=0;
					dispYA(weekcsr,WTiniAL.ALmode[ALCH]);/*@ACR\*/
					blstart(BLINK_no[weekcsr]);
				}
				else if(weekcsr==1){/*	̈ʒuɶقꍇ*/
					f_SOUSAL = 1;
					ALdataAL.hour++;
					if(ALdataAL.hour>=24)		ALdataAL.hour=0;
					weekalTM.hour=ALdataAL.hour;
					dispSetTime(&weekalTM,(KANJI_PUT *)&dispALTIME);
				}
				else if(weekcsr==2){/*	̈ʒuɶقꍇ*/
					f_SOUSAL = 1;
					ALdataAL.min++;
					if(ALdataAL.min>=60)		ALdataAL.min=0;
					weekalTM.min=ALdataAL.min;
					dispSetTime(&weekalTM,(KANJI_PUT *)&dispALTIME);
				}
				else if(weekcsr==3 && sndMAX){
					/*װmodeĂ̈ʒuɶقꍇ*/
					f_SOUSAL = 1;
					WTiniAL.ALmode[ALCH]++;
					if(WTiniAL.ALmode[ALCH]>2)	WTiniAL.ALmode[ALCH]=0;
					lcdfreeze(1);
					for(i=0;i<4;i++){
						pv_sput((SIICODE_PUT *)&PICput[i]);
					}
					pv_put((GVRAM_PUT *)&MMPput[0]);	/*	E	*/
					dispYA(weekcsr,WTiniAL.ALmode[ALCH]);/*@ACR\*/
					pv_kput((KANJI_PUT *)&AlarmModePut[WTiniAL.ALmode[ALCH]]);
					if(WTiniAL.ALmode[ALCH]==1){
						pv_put((GVRAM_PUT *)&MMPput[1]);	/* ذ */
						strncpy(ALdataAL.snd,Sndfile[sndNo],8);
						SNDname[0].str = Sndfile[sndNo];
						pv_kput((KANJI_PUT *)&SNDname[2]);
						pv_kput((KANJI_PUT *)&SNDname[0]);
					}
					/* ذװϰ\@*/
					disp_ALmark(WTiniAL.ALweek[ALCH],WTiniAL.ALmode[ALCH]);
					lcdfreeze(0);
				}
				else if(weekcsr==5 && sndMAX){
					/*	װѻވʒuɶقꍇ	*/
					f_SOUSAL=1;
					sndNo++;
					if(sndNo>=sndMAX)	sndNo=0;
					strncpy(ALdataAL.snd,Sndfile[sndNo],8);
					SNDname[0].str = Sndfile[sndNo];
					pv_kput((KANJI_PUT *)&SNDname[2]);
					pv_kput((KANJI_PUT *)&SNDname[0]);
				}
				else if(7<=weekcsr && weekcsr<=13){	
					/*weeklyݒ̈ʒuɶقꍇ*/
					f_SOUSAL=1;
					for(i=0,k=0x01;i<(weekcsr-7);i++){
							k*=2;
					}
					WTiniAL.ALweek[ALCH] ^= k;
					/* ذװϰ\@*/
					disp_ALmark(WTiniAL.ALweek[ALCH],WTiniAL.ALmode[ALCH]);
				}
			}
			else if( bt==Key_down ){
				if(weekcsr==0 || weekcsr==4){
					/*ق݂̈ʒuɂꍇ*/
					if( WTiniAL.ALmode[ALCH]==2 
						|| (WTiniAL.ALmode[ALCH]==1 && weekcsr==0) ){
						blstop(BLINK_no[weekcsr]);
						if(weekcsr==0)	weekcsr=4;
						else			weekcsr=6;
						dispYA(weekcsr,WTiniAL.ALmode[ALCH]);
										/*ACR\*/
						blstart(BLINK_no[weekcsr]);
					}
				}
				else if(weekcsr==1){/*	̈ʒuɶقꍇ*/
					f_SOUSAL=1;
					if(!ALdataAL.hour)	ALdataAL.hour=23;
					else				ALdataAL.hour--;
					weekalTM.hour=ALdataAL.hour;
					dispSetTime(&weekalTM,(KANJI_PUT *)&dispALTIME);
				}
				else if(weekcsr==2){/*	̈ʒuɶقꍇ*/
					f_SOUSAL=1;
					if(!ALdataAL.min)	ALdataAL.min=59;
					else					ALdataAL.min--;
					weekalTM.min=ALdataAL.min;
					dispSetTime(&weekalTM,(KANJI_PUT *)&dispALTIME);
				}
				else if(weekcsr==3 && sndMAX){
					/*	װmodeĂ̈ʒuɶقꍇ*/
					f_SOUSAL=1;
					WTiniAL.ALmode[ALCH]--;
					if(WTiniAL.ALmode[ALCH]<0)	WTiniAL.ALmode[ALCH]=2;
					lcdfreeze(1);
					for(i=0;i<4;i++){
						pv_sput((SIICODE_PUT *)&PICput[i]);
					}
					pv_put((GVRAM_PUT *)&MMPput[0]);	/*	E	*/
					dispYA(weekcsr,WTiniAL.ALmode[ALCH]);/*@ACR\*/
					pv_kput((KANJI_PUT *)&AlarmModePut[WTiniAL.ALmode[ALCH]]);
														/* Ӱޕ\ */
					if(WTiniAL.ALmode[ALCH]==2){
						pv_put((GVRAM_PUT *)&MMPput[1]);	/* ذ\@\*/
						strncpy(ALdataAL.snd,Sndfile[sndNo],8);
						SNDname[0].str = Sndfile[sndNo];
						pv_kput((KANJI_PUT *)&SNDname[2]);
						pv_kput((KANJI_PUT *)&SNDname[0]);/* ̧ٖ */
					}
					disp_ALmark(WTiniAL.ALweek[ALCH],WTiniAL.ALmode[ALCH]);
													/* ذװϰ\@*/
					lcdfreeze(0);
				}
				else if(weekcsr==5 && sndMAX){
					/*	װѻވʒuɶقꍇ	*/
					f_SOUSAL=1;
					sndNo--;
					if(sndNo<0)	sndNo=sndMAX-1;
					strncpy(ALdataAL.snd,Sndfile[sndNo],8);
					SNDname[0].str = Sndfile[sndNo];
					pv_kput((KANJI_PUT *)&SNDname[2]);
					pv_kput((KANJI_PUT *)&SNDname[0]);
				}
				else if(7<=weekcsr && weekcsr<=13){	
					/*weeklyݒ̈ʒuɶقꍇ*/
					f_SOUSAL=1;
					for(i=0,k=0x01;i<(weekcsr-7);i++){
							k*=2;
					}
					WTiniAL.ALweek[ALCH] ^= k;
					/* ذװϰ\@*/
					disp_ALmark(WTiniAL.ALweek[ALCH],WTiniAL.ALmode[ALCH]);
				}
			}
			else if(bt==Key_left && weekcsr!=0 && weekcsr!=4 && weekcsr!=6){
				blstop(BLINK_no[weekcsr]);
				weekcsr--;
				blstart(BLINK_no[weekcsr]);
				if(weekcsr==0 || weekcsr==4 || weekcsr==6)
											REPkey=0;
				else if(weekcsr==2)			REPkey=(Key_up|Key_down);
				if(WTiniAL.ALmode[ALCH]==0){
					if(weekcsr==0)	pv_sput((SIICODE_PUT *)&YAput[0]);
					else			pv_sput((SIICODE_PUT *)&YAput[1]);
				}
				else	dispYA(weekcsr,WTiniAL.ALmode[ALCH]);
											/*@ACR\*/
			}
			else if(bt==Key_right && weekcsr!=3 && weekcsr!= 13){
				if(!(WTiniAL.ALmode[ALCH]==1 && weekcsr==6)){
					if(weekcsr==5){
						blstop(BLINK_no[weekcsr]);
						alsoundDEMO((char *)&Sndfile[sndNo]);
												/*		*/
						blstart(BLINK_no[weekcsr]);
						REPkey=0;
					}
					else{
						blstop(BLINK_no[weekcsr]);
						weekcsr++;
						blstart(BLINK_no[weekcsr]);
						if(weekcsr==3 )		REPkey=0;
						else if(weekcsr==1 || weekcsr==5 )	
											REPkey=(Key_up|Key_down);
						if(WTiniAL.ALmode[ALCH]==0){
							pv_sput((SIICODE_PUT *)&YAput[1]);
						}
						else	dispYA(weekcsr,WTiniAL.ALmode[ALCH]);
											/*@ACR\*/
					}
				}
			}
		}
	}
}
/*-----------------------------------------------------------*/
/*	 A[ݒ											 */
/*-----------------------------------------------------------*/
int alarm(void)
{
	int BLINK_no[16];
	int	bt,ret;
	int cansel;
	int i;
	int csr;
	int REPkey=(Key_up|Key_down);
	int fp;
	const BLINK_DRAW alBLINK[]={
		{{1,12,13,25},0x00a0},	/**/
		{{39,12,49,25},0x00a0},	/**/
		{{57,12,68,25},0x00a0},	/**/
		{{72,12,94,25},0x00a0},	/*mode*/
		{{1,25,13,38},0x00a0},	/**/
		{{39,25,49,38},0x00a0},	/**/
		{{57,25,68,38},0x00a0},	/**/
		{{72,25,94,38},0x00a0},	/*mode*/
		{{1,38,13,51},0x00a0},	/**/
		{{39,38,49,51},0x00a0},	/**/
		{{57,38,68,51},0x00a0},	/**/
		{{72,38,94,51},0x00a0},	/*mode*/
		{{1,51,13,64},0x00a0},	/**/
		{{39,51,49,64},0x00a0},	/**/
		{{57,51,68,64},0x00a0},	/**/
		{{72,51,94,64},0x00a0},	/*mode*/
	};
	const SIICODE_PUT PICput[]={
		{{1,13},picAL1,0},
		{{1,26},picAL2,0},
		{{1,39},picAL3,0},
		{{1,52},picAL4,0}
	};
	SIICODE_PUT YAput[]={
		{{13,13},0,0},
		{{13,26},0,0},
		{{13,39},0,0},
		{{13,52},0,0}
	};
	KANJI_PUT dispALTIME[]={
			{{25,0},0,12,1,0},		/*	AM/PM	*/
			{{39,0},0,19,1,0},		/*		*/
			{{51,0},0,19,1,0},		/*	F	*/
			{{57,0},0,19,1,0},		/*		*/
	};
	GVRAM_PUT MMPput={{97,0},(char *)mmpRYAs,0};

	f_SOUSA = 0;
	csr = 0;
	/*	WEEKLY.INI̳رװްذ	*/
	fp=dos_fopen( WEEKLYALARM, 0 );
	if( fp==-2 ){/* dُ */
		dispVOLerr();
		dos_exit(0);
	}
	dos_fread(fp,(char *)&ALdata,(int)(sizeof(WEEKLYTABLE)*4));
	dos_fread(fp,(char *)&WTini,sizeof(WATCH));
	dos_fclose(fp);
	memset( Sndfile, 0 ,sizeof(Sndfile) );
	sndMAX = GetSndFileName( Sndfile );/* װѻ̧ق̎擾 */
	if( !sndMAX ){/* ̧قPȂ */
		if( dispMess( (char **)SndNoFileErr, 2 )==-1 )	dos_exit(0);
		return(0);
	}

	while(1){
		pv_clear((RECT *)&CLRLCD);
		lcdfreeze(1);
		for(i=0;i<16;i++){
			BLINK_no[i]=pblink((BLINK_DRAW *)&alBLINK[i]);
			blstop(BLINK_no[i]);
		}
		for(i=0;i<4;i++){/* ʕ\ */
			pv_sput((SIICODE_PUT *)&PICput[i]);
			if(csr==i*4)						YAput[i].code=picRYAB;
			else if((i*4<csr)&&(csr<=i*4+3))	YAput[i].code=picLYAB;
			else								YAput[i].code=picRYAW;
			pv_sput((SIICODE_PUT *)&YAput[i]);
			alTM.hour=ALdata[i].hour;
			alTM.min=ALdata[i].min;
			dispALTIME[0].pos.y=17+13*i;
			dispALTIME[1].pos.y=14+13*i;
			dispALTIME[2].pos.y=14+13*i;
			dispALTIME[3].pos.y=14+13*i;
			dispSetTime(&alTM,(KANJI_PUT *)&dispALTIME);
			AlarmModePut[WTini.ALmode[i]].pos.y=17+13*i;
			pv_kput((KANJI_PUT *)&AlarmModePut[WTini.ALmode[i]]);
			MMPput.pos.y=13+13*i;
			pv_put((GVRAM_PUT *)&MMPput);/* E\@*/
		}
		dispTitle("װѾ");
		lcdfreeze(0);
		blstart(BLINK_no[csr]);

		while(1){
			bt=Keyin(REPkey,BLINK_no[csr]);
			bt&=~Key_file;/* ̧װ𖳌ɂ */
			ret = EventCall(bt);
			if (ret == -1) {
				for(i=0;i<16;i++)	blend(BLINK_no[i]);/*	BLINK	*/
				dos_exit(1);/* عݏIv */
			}
			else if (ret == 1) {
				for(i=0;i<16;i++)	blend(BLINK_no[i]);/*	BLINK	*/
				ret = EventExec();
				if (ret == -1) {
					dos_exit(1);/* عݏIv */
				}
				break;
			}
			if(bt==Key_enter){
				if(0<(csr%4)){	/*	݂̈ʒuȊOɶقꍇ	*/
					blstop(BLINK_no[csr]);
					csr=(csr/4)*4;
					blstart(BLINK_no[csr]);
					YAput[csr/4].code=picRYAB;
					pv_sput((SIICODE_PUT *)&YAput[csr/4]);
				}
				else{
					for(i=0;i<16;i++)	blend(BLINK_no[i]);/*	BLINK	*/
					if(!f_SOUSA)	return(0);
					dispMessBar("XV");
					for(i=0;i<4;i++){
						switch(WTini.ALmode[i]){
							case 0: ALdata[i].week=0;				/*OFF	*/
									break;
							case 1: ALdata[i].week=0xff;			/*DAYLY	*/
									break;
							case 2: ALdata[i].week=WTini.ALweek[i];	/*WEEKLY*/
						}
					}
					if((fp=dos_fopen( WEEKLYALARM, 1 ))==-1){
						/* WEEKLY.INIȂꍇz */
						fp = dos_fcreate( WEEKLYALARM );
					}
					else if( fp==-2 ){/* dُ */
						dispVOLerr();
						dos_exit(0);
					}
					dos_fwrite(fp,(char *)&ALdata,(int)(sizeof(WEEKLYTABLE)*4));
					dos_fwrite(fp,(char *)&WTini,(int)(sizeof(WATCH)));
					dos_fclose(fp);
					bi_vwrflush();
					setWeeklyAlarm();
					endMessBar();
					return(-1);
				}
			}
			else if(bt==Key_menu){
				for(i=0;i<16;i++)	blend(BLINK_no[i]);/*	BLINK	*/
				if(f_SOUSA){
					cansel=dispCancelYN();			/*	ݒ̷ݾ	*/
					if( cansel == -1 ) dos_exit(0);
					if(cansel)	break;			/*	ݾNOȂ畜A	*/
				}
				return(0);
			}
			else if(bt==Key_up){
				if(csr!=0 && csr%4==0){/*݈ʒuɶقꍇ*/
					blstop(BLINK_no[csr]);
					YAput[csr/4].code=picRYAW;
					pv_sput((SIICODE_PUT *)&YAput[csr/4]);
					csr-=4;
					YAput[csr/4].code=picRYAB;
					pv_sput((SIICODE_PUT *)&YAput[csr/4]);
					blstart(BLINK_no[csr]);
				}
				else if(csr%4==1){/*װю̈ʒuɶقꍇ*/
					f_SOUSA=1;
					ALdata[csr/4].hour++;
					if(ALdata[csr/4].hour>=24)		ALdata[csr/4].hour=0;
					alTM.hour=ALdata[csr/4].hour;
					alTM.min=ALdata[csr/4].min;
					dispALTIME[0].pos.y=17+13*(csr/4);
					dispALTIME[1].pos.y=14+13*(csr/4);
					dispALTIME[2].pos.y=14+13*(csr/4);
					dispALTIME[3].pos.y=14+13*(csr/4);
					dispSetTime(&alTM,(KANJI_PUT *)&dispALTIME);
				}
				else if(csr%4==2){/*װѕ̈ʒuɶقꍇ*/
					f_SOUSA=1;
					ALdata[csr/4].min++;
					if(ALdata[csr/4].min>=60)		ALdata[csr/4].min=0;
					alTM.hour=ALdata[csr/4].hour;
					alTM.min=ALdata[csr/4].min;
					dispALTIME[0].pos.y=17+13*(csr/4);
					dispALTIME[1].pos.y=14+13*(csr/4);
					dispALTIME[2].pos.y=14+13*(csr/4);
					dispALTIME[3].pos.y=14+13*(csr/4);
					dispSetTime(&alTM,(KANJI_PUT *)&dispALTIME);
				}
				else if(csr%4==3){/*װmodeĂ̈ʒuɶقꍇ*/
					f_SOUSA=1;
					WTini.ALmode[csr/4]+=1;
					if(WTini.ALmode[csr/4]>2)	WTini.ALmode[csr/4]=0;
					if( !ALdata[csr/4].snd[0] && sndMAX ){
						strncpy( ALdata[csr/4].snd, (char *)&Sndfile[0],8);
					}
					AlarmModePut[WTini.ALmode[csr/4]].pos.y=17+13*(csr/4);
					pv_kput((KANJI_PUT *)&AlarmModePut[WTini.ALmode[csr/4]]);
				}
			}
			else if(bt==Key_down){/*݈ʒuɶقꍇ*/
				if(csr%4==0 && csr!=12){
					blstop(BLINK_no[csr]);
					YAput[csr/4].code=picRYAW;
					pv_sput((SIICODE_PUT *)&YAput[csr/4]);
					csr+=4;
					YAput[csr/4].code=picRYAB;
					pv_sput((SIICODE_PUT *)&YAput[csr/4]);
					blstart(BLINK_no[csr]);
				}
				else if(csr%4==1){/*װю̈ʒuɶقꍇ*/
					f_SOUSA=1;
					if(!ALdata[csr/4].hour)	ALdata[csr/4].hour=23;
					else					ALdata[csr/4].hour--;
					alTM.hour=ALdata[csr/4].hour;
					alTM.min=ALdata[csr/4].min;
					dispALTIME[0].pos.y=17+13*(csr/4);
					dispALTIME[1].pos.y=14+13*(csr/4);
					dispALTIME[2].pos.y=14+13*(csr/4);
					dispALTIME[3].pos.y=14+13*(csr/4);
					dispSetTime(&alTM,(KANJI_PUT *)&dispALTIME);
				}
				else if(csr%4==2){/*װѕ̈ʒuɶقꍇ*/
					f_SOUSA=1;
					if(!ALdata[csr/4].min)		ALdata[csr/4].min=59;
					else						ALdata[csr/4].min--;
					alTM.hour=ALdata[csr/4].hour;
					alTM.min=ALdata[csr/4].min;
					dispALTIME[0].pos.y=17+13*(csr/4);
					dispALTIME[1].pos.y=14+13*(csr/4);
					dispALTIME[2].pos.y=14+13*(csr/4);
					dispALTIME[3].pos.y=14+13*(csr/4);
					dispSetTime(&alTM,(KANJI_PUT *)&dispALTIME);
				}
				else if(csr%4==3){/*װmodeĂ̈ʒuɶقꍇ*/
					f_SOUSA=1;
					WTini.ALmode[csr/4]-=1;
					if(WTini.ALmode[csr/4]<0)	WTini.ALmode[csr/4]=2;
					if( !ALdata[csr/4].snd[0] && sndMAX ){
						strncpy( ALdata[csr/4].snd, (char *)&Sndfile[0],8);
					}
					AlarmModePut[WTini.ALmode[csr/4]].pos.y=17+13*(csr/4);
					pv_kput((KANJI_PUT *)&AlarmModePut[WTini.ALmode[csr/4]]);
				}
			}
			else if(bt==Key_right){
				if(csr%4==3){/*װmodeĂ̈ʒuɶقꍇ*/
					for(i=0;i<16;i++)	blend(BLINK_no[i]);		/*	BLINK	*/
					weeklyal(csr);
									/*	ڍױװѐݒ	*/
					csr=(csr/4)*4;
					break;
				}
				else{
					blstop(BLINK_no[csr]);
					csr++;
					if(csr%4==1 || csr%4==2)	REPkey=(Key_up|Key_down);
					else						REPkey=0;
					blstart(BLINK_no[csr]);
					if(csr%4==1){/*װю̈ʒuɶقړꍇ*/
						YAput[csr/4].code=picLYAB;
						pv_sput((SIICODE_PUT *)&YAput[csr/4]);
					}
				}
			}
			else if(bt==Key_left && csr%4!=0){
				blstop(BLINK_no[csr]);
				csr--;
				if(csr%4==1 || csr%4==2)	REPkey=(Key_up|Key_down);
				else						REPkey=0;
				blstart(BLINK_no[csr]);
				if(csr%4==0){/*װѱ݂̈ʒuɶقړꍇ*/
					YAput[csr/4].code=picRYAB;
					pv_sput((SIICODE_PUT *)&YAput[csr/4]);
				}
			}
		}
	}
}
