/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*                                                                      */
/* @\T		:	\tgL[{[h̋N                              */
/*                                                                      */
/*======================================================================*/

#include "rupsys.h"

int convGnuToPanaxPPIP(void*,void*,int,void*,int*);

/*
	ķް
*/
int softkey(void *sts, char *str ,int mode,char *fname)
{
	int rst;
	rst = convGnuToPanaxPPIP((void*)sts,(void*)str,mode,(void*)fname,
											(int*)pSystemCtl->softkey);
	return rst;
}

/*=================== GNUPanax ======================*/
/*                 WX^ϊ                    */
/*=====================================================*/
int convGnuToPanaxPPIP(void *p0,void *p1,int i,void *p2,int *func)
{
	/* 1WX^	GNU=D0,Panax=A0			*/
	/* 2WX^	GNU=D1,Panax=D1			*/
	/* 3WX^	GNU=A2+0(+4),Panax=D0	*/
	/* 4WX^	GNU=A2+2(+4),Panax=A3+0E*/
	/* ֐Ăяo		A2+6(+4)  A1			*/
	asm("
		add		-8,A3							#
		mov		A0,(0,A3)						#
		mov		A1,(4,A3)						#

		add		-0x12,A3		#zPanaxX^bNm 4+3*4byte+1*2byte
			movx	D0,(0x04,A3)	#arg1ݒ
			mov		D0,A0

			movx	D1,(0x08,A3)	#arg2ݒ

			mov		(0x04,A2),D0	#A2 4(ret܂)
			mov		D0,(0x0C,A3)	#arg3ݒ

			mov		(0x06,A2),A1
			mov		A1,(0x0E,A3)	#arg4ݒ

			mov		(0x0A,A2),A1			#֐ݒ
			jsr		(A1)
		add		0x12,A3			#zPanaxX^bN

		mov		(0,A3),A0						#
		mov		(4,A3),A1						#
		add		8,A3							#
	");
}
