/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*                                                                      */
/*@\T      :   t@CT[rXJn/I                           */
/*                                                                      */
/*======================================================================*/

#include "psdos.h"
#include "rupsys.h"

SYSTEMCTL	*pSystemCtl;			/*   RuputerVXe        */

static long toAddrbin(char*);

/*
	APIT[rXn
*/
void InitRupAPI(void)
{
	char *psp;
	char buf[9];
	int i;

	/* PSP̎擾 */
	psp = (char *)dos_get_psp() + 0x80;
	/* я̎擾 */
	for(i = 0;i < 8;i++) buf[i] = *psp++;
	buf[8] = '\0';
	pSystemCtl = (SYSTEMCTL *)toAddrbin(buf);
}

/*
	APIT[rXI
*/
void EndRupAPI(void)
{
	screen(LCD_GRAPH);
	gv_place(0,0);
	EVENTREGSTER = 1;
}


static long toAddrbin(char *str)
{
	long adr;
	adr = 0;
	for(;*str != (char)'\0';str++) {
		adr = adr << 4;
		if (('0' <= *str) && (*str <= '9'))
			adr = adr + (*str - '0');
		else if (('a' <= *str) && (*str <= 'f'))
			adr = adr + 10 + (*str - 'a');
		else if (('A' <= *str) && (*str <= 'F'))
			adr = adr + 10 + (*str - 'A');
	}
	return adr;
}

