/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*                                                                      */
/*@\T		:	ptHg̕񕝎Zo                          */
/*                                                                      */
/*======================================================================*/

#include<string.h>

int getUsWdot(int scode, char *moji)
{
	const static unsigned char Ss[3] = {
		0x14,			/* scode=5 12dot */
		0x12,			/* scode=6 10dot */
		0x08			/* scode=7  8dot */
	};
	const static unsigned long Sp[3] = {
		0x207C50,		/* scode=5 12dot */
		0x2083BC,		/* scode=6 10dot */
		0x208A6A		/* scode=7  8dot */
	};
	int		i,len,dot=0;

	scode-=5;
	/* TCYR[h̊mF */
	if ((unsigned int)scode>2)
		return( -1 );
	len=strlen(moji);
	for(i=0;i<len;i++){
		if(0x20<=moji[i]&&moji[i]<=0x7E){	/* pł */
			dot+=*(unsigned char*)(Ss[scode]*(moji[i]-0x20)+Sp[scode]);
		}else{
			return( -1 );
		}
	}
	return( dot );
}
