/*======================================================================*/
/*vWFNg:RUPUTER                                                */
/*      Copyright (c) Seiko Instruments Inc. 1998. All rights reserved. */
/*======================================================================*/

#include "b_common.h"

/*======================================================================*/
/*	֐	:bi_cominit    0x01											*/
/*																		*/
/*	@\	:ʐM|[g̏@@@@@@@@@@@@					*/
/*																		*/
/*		:int bi_cominit(int, int, int, int)							*/
/*																		*/
/*		:ʐMA{[[gApXA^CAEgl		@@ 	*/
/*																		*/
/*	֐l	:OFI@|PFُI@@@@@@@@@				*/
/*																		*/
/*======================================================================*/
int bi_cominit(int comdev, int baud, int pulse, int timout)
{
	REGS	i_regs;
	REGS	o_regs;

	i_regs.d0 = INT_COMINIT;
	i_regs.d1 = comdev & 0xffff;						/* ʐM			*/
	i_regs.d2 = baud   & 0xffff;						/* {[[g		*/
	if (comdev == 1) {
		i_regs.a1 = pulse & 0xffff;						/* pX			*/
	}
	i_regs.a2 = timout & 0xffff;						/* ^CAEgl	*/

	_intbios(&i_regs, &o_regs);

	if ((int)o_regs.d1 == 0) {
		return(0);
	} else {
		BIOSerr = (int)o_regs.d1;						/* G[R[h		*/
		return(-1);
	}
}
